/* baobab-scanner.c generated by valac 0.56.17, the Vala compiler
 * generated from baobab-scanner.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2012  Ryan Lortie <desrt@desrt.ca>
 * Copyright (C) 2012  Paolo Borelli <pborelli@gnome.org>
 * Copyright (C) 2012  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "baobab.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#define BAOBAB_SCANNER_ATTRIBUTES G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE "," G_FILE_ATTRIBUTE_TIME_MODIFIED "," G_FILE_ATTRIBUTE_UNIX_NLINK "," G_FILE_ATTRIBUTE_UNIX_INODE "," G_FILE_ATTRIBUTE_UNIX_DEVICE "," G_FILE_ATTRIBUTE_ACCESS_CAN_READ
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef struct _BaobabScannerHardLink BaobabScannerHardLink;
typedef struct _BaobabScannerResultsArray BaobabScannerResultsArray;
enum  {
	BAOBAB_SCANNER_0_PROPERTY,
	BAOBAB_SCANNER_ROOT_PROPERTY,
	BAOBAB_SCANNER_DIRECTORY_PROPERTY,
	BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY,
	BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY,
	BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY,
	BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY,
	BAOBAB_SCANNER_MAX_DEPTH_PROPERTY,
	BAOBAB_SCANNER_NUM_PROPERTIES
};
static GParamSpec* baobab_scanner_properties[BAOBAB_SCANNER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_async_queue_unref0(var) ((var == NULL) ? NULL : (var = (g_async_queue_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _baobab_scanner_hard_link_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_hard_link_free (var), NULL)))
#define _baobab_scanner_results_array_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_results_array_free (var), NULL)))
enum  {
	BAOBAB_SCANNER_RESULTS_0_PROPERTY,
	BAOBAB_SCANNER_RESULTS_PARENT_PROPERTY,
	BAOBAB_SCANNER_RESULTS_NAME_PROPERTY,
	BAOBAB_SCANNER_RESULTS_DISPLAY_NAME_PROPERTY,
	BAOBAB_SCANNER_RESULTS_SIZE_PROPERTY,
	BAOBAB_SCANNER_RESULTS_TIME_MODIFIED_PROPERTY,
	BAOBAB_SCANNER_RESULTS_ELEMENTS_PROPERTY,
	BAOBAB_SCANNER_RESULTS_PERCENT_PROPERTY,
	BAOBAB_SCANNER_RESULTS_CHILDREN_LIST_STORE_PROPERTY,
	BAOBAB_SCANNER_RESULTS_STATE_PROPERTY,
	BAOBAB_SCANNER_RESULTS_FRACTION_PROPERTY,
	BAOBAB_SCANNER_RESULTS_IS_EMPTY_PROPERTY,
	BAOBAB_SCANNER_RESULTS_NUM_PROPERTIES
};
static GParamSpec* baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_NUM_PROPERTIES];
enum  {
	BAOBAB_SCANNER_COMPLETED_SIGNAL,
	BAOBAB_SCANNER_NUM_SIGNALS
};
static guint baobab_scanner_signals[BAOBAB_SCANNER_NUM_SIGNALS] = {0};

struct _BaobabScannerPrivate {
	BaobabScannerResults* _root;
	GFile* _directory;
	BaobabScanFlags _scan_flags;
	gboolean _show_allocated_size;
	guint64 _total_size;
	gint _total_elements;
	gint _max_depth;
	GThread* thread;
	guint process_result_idle;
	GHashTable* hardlinks;
	GHashTable* excluded_locations;
	guint32 unix_device;
	gboolean successful;
	GAsyncQueue* results_queue;
	BaobabScanner* self;
	GCancellable* cancellable;
	GError* scan_error;
};

struct _BaobabScannerResultsArray {
	BaobabScannerResults** results;
	gint results_length1;
	gint _results_size_;
};

struct _BaobabScannerHardLink {
	guint64 inode;
	guint32 device;
};

struct _BaobabScannerResultsPrivate {
	BaobabScannerResults* _parent;
	gchar* _name;
	gchar* _display_name;
	guint64 _size;
	guint64 _time_modified;
	gint _elements;
	gdouble _percent;
	GListStore* _children_list_store;
	BaobabScannerState _state;
};

static gint BaobabScanner_private_offset;
static gpointer baobab_scanner_parent_class = NULL;
static gint BaobabScannerResults_private_offset;
static gpointer baobab_scanner_results_parent_class = NULL;

static void baobab_scanner_hard_link_free (BaobabScannerHardLink * self);
static void baobab_scanner_results_array_free (BaobabScannerResultsArray * self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void baobab_scanner_add_children (BaobabScanner* self,
                                  GFile* directory,
                                  BaobabScannerResults* results,
                                  BaobabScannerResultsArray* results_array,
                                  GError** error);
static BaobabScannerResults* baobab_scanner_add_directory (BaobabScanner* self,
                                                    GFile* directory,
                                                    GFileInfo* info,
                                                    BaobabScannerResults* parent);
static void _vala_array_add3 (BaobabScannerResults** * array,
                       gint* length,
                       gint* size,
                       BaobabScannerResults* value);
static BaobabScannerHardLink* baobab_scanner_hard_link_new (GFileInfo* info);
static void baobab_scanner_set_total_size (BaobabScanner* self,
                                    guint64 value);
static void baobab_scanner_set_total_elements (BaobabScanner* self,
                                        gint value);
static void _vala_array_add4 (BaobabScannerResults** * array,
                       gint* length,
                       gint* size,
                       BaobabScannerResults* value);
static BaobabScannerResultsArray* baobab_scanner_results_array_new (void);
VALA_EXTERN void baobab_scanner_results_set_percent (BaobabScannerResults* self,
                                         gdouble value);
static void* baobab_scanner_scan_in_thread (BaobabScanner* self);
static void baobab_scanner_set_show_allocated_size (BaobabScanner* self,
                                             gboolean value);
static void _vala_array_add5 (BaobabScannerResults** * array,
                       gint* length,
                       gint* size,
                       BaobabScannerResults* value);
static gboolean baobab_scanner_process_results (BaobabScanner* self);
VALA_EXTERN void baobab_scanner_results_set_state (BaobabScannerResults* self,
                                       BaobabScannerState value);
static void baobab_scanner_cancel_and_reset (BaobabScanner* self);
static guint baobab_scanner_hard_link_hash (BaobabScannerHardLink* self);
static guint _baobab_scanner_hard_link_hash_ghash_func (gconstpointer key);
static gboolean baobab_scanner_hard_link_equal (BaobabScannerHardLink* self,
                                         BaobabScannerHardLink* other);
static gboolean _baobab_scanner_hard_link_equal_gequal_func (gconstpointer a,
                                                      gconstpointer b);
static void _baobab_scanner_hard_link_free0_ (gpointer var);
static gpointer _baobab_scanner_scan_in_thread_gthread_func (gpointer self);
static gboolean ___lambda6_ (BaobabScanner* self);
static gboolean ____lambda6__gsource_func (gpointer self);
static void baobab_scanner_set_directory (BaobabScanner* self,
                                   GFile* value);
static void baobab_scanner_set_scan_flags (BaobabScanner* self,
                                    BaobabScanFlags value);
static void _baobab_scanner_results_array_free0_ (gpointer var);
static void baobab_scanner_hard_link_instance_init (BaobabScannerHardLink * self);
static void baobab_scanner_results_array_instance_init (BaobabScannerResultsArray * self);
VALA_EXTERN void baobab_scanner_results_set_parent (BaobabScannerResults* self,
                                        BaobabScannerResults* value);
VALA_EXTERN void baobab_scanner_results_set_name (BaobabScannerResults* self,
                                      const gchar* value);
VALA_EXTERN void baobab_scanner_results_set_display_name (BaobabScannerResults* self,
                                              const gchar* value);
VALA_EXTERN void baobab_scanner_results_set_size (BaobabScannerResults* self,
                                      guint64 value);
VALA_EXTERN void baobab_scanner_results_set_time_modified (BaobabScannerResults* self,
                                               guint64 value);
VALA_EXTERN void baobab_scanner_results_set_elements (BaobabScannerResults* self,
                                          gint value);
static GListModel* __lambda4_ (BaobabScannerResults* self,
                        GObject* item);
static GListModel* ___lambda4__gtk_tree_list_model_create_model_func (GObject* item,
                                                               gpointer self);
static GObject * baobab_scanner_results_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _baobab_scanner_results___lambda5_ (BaobabScannerResults* self);
static void __baobab_scanner_results___lambda5__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void baobab_scanner_results_finalize (GObject * obj);
static GType baobab_scanner_results_get_type_once (void);
static void _vala_baobab_scanner_results_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_baobab_scanner_results_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void baobab_scanner_finalize (GObject * obj);
static GType baobab_scanner_get_type_once (void);
static void _vala_baobab_scanner_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_baobab_scanner_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GType
baobab_scan_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{BAOBAB_SCAN_FLAGS_NONE, "BAOBAB_SCAN_FLAGS_NONE", "none"}, {BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS, "BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS", "exclude-mounts"}, {0, NULL, NULL}};
	GType baobab_scan_flags_type_id;
	baobab_scan_flags_type_id = g_flags_register_static ("BaobabScanFlags", values);
	return baobab_scan_flags_type_id;
}

GType
baobab_scan_flags_get_type (void)
{
	static volatile gsize baobab_scan_flags_type_id__once = 0;
	if (g_once_init_enter (&baobab_scan_flags_type_id__once)) {
		GType baobab_scan_flags_type_id;
		baobab_scan_flags_type_id = baobab_scan_flags_get_type_once ();
		g_once_init_leave (&baobab_scan_flags_type_id__once, baobab_scan_flags_type_id);
	}
	return baobab_scan_flags_type_id__once;
}

static inline gpointer
baobab_scanner_get_instance_private (BaobabScanner* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabScanner_private_offset);
}

static GType
baobab_scanner_state_get_type_once (void)
{
	static const GEnumValue values[] = {{BAOBAB_SCANNER_STATE_SCANNING, "BAOBAB_SCANNER_STATE_SCANNING", "scanning"}, {BAOBAB_SCANNER_STATE_ERROR, "BAOBAB_SCANNER_STATE_ERROR", "error"}, {BAOBAB_SCANNER_STATE_CHILD_ERROR, "BAOBAB_SCANNER_STATE_CHILD_ERROR", "child-error"}, {BAOBAB_SCANNER_STATE_DONE, "BAOBAB_SCANNER_STATE_DONE", "done"}, {0, NULL, NULL}};
	GType baobab_scanner_state_type_id;
	baobab_scanner_state_type_id = g_enum_register_static ("BaobabScannerState", values);
	return baobab_scanner_state_type_id;
}

GType
baobab_scanner_state_get_type (void)
{
	static volatile gsize baobab_scanner_state_type_id__once = 0;
	if (g_once_init_enter (&baobab_scanner_state_type_id__once)) {
		GType baobab_scanner_state_type_id;
		baobab_scanner_state_type_id = baobab_scanner_state_get_type_once ();
		g_once_init_leave (&baobab_scanner_state_type_id__once, baobab_scanner_state_type_id);
	}
	return baobab_scanner_state_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/baobab-scanner.vala"
	return self ? g_object_ref (self) : NULL;
#line 299 "baobab-scanner.c"
}

static void
_g_free0_ (gpointer var)
{
#line 67 "../src/baobab-scanner.vala"
	var = (g_free (var), NULL);
#line 307 "baobab-scanner.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 67 "../src/baobab-scanner.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 315 "baobab-scanner.c"
}

GFile*
baobab_scanner_get_file (BaobabScanner* self,
                         BaobabScannerResults* results)
{
	GList* names = NULL;
	GFile* file = NULL;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GList* _tmp13_;
	GList* _tmp14_;
	GFile* result;
#line 55 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/baobab-scanner.vala"
	g_return_val_if_fail (results != NULL, NULL);
#line 56 "../src/baobab-scanner.vala"
	names = NULL;
#line 335 "baobab-scanner.c"
	{
		BaobabScannerResults* child = NULL;
		BaobabScannerResults* _tmp0_;
#line 58 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (results);
#line 58 "../src/baobab-scanner.vala"
		child = _tmp0_;
#line 343 "baobab-scanner.c"
		{
			gboolean _tmp1_ = FALSE;
#line 58 "../src/baobab-scanner.vala"
			_tmp1_ = TRUE;
#line 58 "../src/baobab-scanner.vala"
			while (TRUE) {
#line 350 "baobab-scanner.c"
				BaobabScannerResults* _tmp6_;
				BaobabScannerResults* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 58 "../src/baobab-scanner.vala"
				if (!_tmp1_) {
#line 358 "baobab-scanner.c"
					BaobabScannerResults* _tmp2_;
					BaobabScannerResults* _tmp3_;
					BaobabScannerResults* _tmp4_;
					BaobabScannerResults* _tmp5_;
#line 58 "../src/baobab-scanner.vala"
					_tmp2_ = child;
#line 58 "../src/baobab-scanner.vala"
					_tmp3_ = baobab_scanner_results_get_parent (_tmp2_);
#line 58 "../src/baobab-scanner.vala"
					_tmp4_ = _tmp3_;
#line 58 "../src/baobab-scanner.vala"
					_tmp5_ = _g_object_ref0 (_tmp4_);
#line 58 "../src/baobab-scanner.vala"
					_g_object_unref0 (child);
#line 58 "../src/baobab-scanner.vala"
					child = _tmp5_;
#line 375 "baobab-scanner.c"
				}
#line 58 "../src/baobab-scanner.vala"
				_tmp1_ = FALSE;
#line 58 "../src/baobab-scanner.vala"
				_tmp6_ = child;
#line 58 "../src/baobab-scanner.vala"
				if (!(_tmp6_ != NULL)) {
#line 58 "../src/baobab-scanner.vala"
					break;
#line 385 "baobab-scanner.c"
				}
#line 59 "../src/baobab-scanner.vala"
				_tmp7_ = child;
#line 59 "../src/baobab-scanner.vala"
				_tmp8_ = baobab_scanner_results_get_name (_tmp7_);
#line 59 "../src/baobab-scanner.vala"
				_tmp9_ = _tmp8_;
#line 59 "../src/baobab-scanner.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 59 "../src/baobab-scanner.vala"
				names = g_list_prepend (names, _tmp10_);
#line 397 "baobab-scanner.c"
			}
		}
#line 58 "../src/baobab-scanner.vala"
		_g_object_unref0 (child);
#line 402 "baobab-scanner.c"
	}
#line 62 "../src/baobab-scanner.vala"
	_tmp11_ = self->priv->_directory;
#line 62 "../src/baobab-scanner.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 62 "../src/baobab-scanner.vala"
	file = _tmp12_;
#line 63 "../src/baobab-scanner.vala"
	_tmp13_ = names;
#line 63 "../src/baobab-scanner.vala"
	_tmp14_ = _tmp13_->next;
#line 414 "baobab-scanner.c"
	{
		GList* name_collection = NULL;
		GList* name_it = NULL;
#line 63 "../src/baobab-scanner.vala"
		name_collection = _tmp14_;
#line 63 "../src/baobab-scanner.vala"
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 422 "baobab-scanner.c"
			gchar* _tmp15_;
			gchar* name = NULL;
#line 63 "../src/baobab-scanner.vala"
			_tmp15_ = g_strdup ((const gchar*) name_it->data);
#line 63 "../src/baobab-scanner.vala"
			name = _tmp15_;
#line 429 "baobab-scanner.c"
			{
				GFile* _tmp16_;
				const gchar* _tmp17_;
				GFile* _tmp18_;
#line 64 "../src/baobab-scanner.vala"
				_tmp16_ = file;
#line 64 "../src/baobab-scanner.vala"
				_tmp17_ = name;
#line 64 "../src/baobab-scanner.vala"
				_tmp18_ = g_file_get_child (_tmp16_, _tmp17_);
#line 64 "../src/baobab-scanner.vala"
				_g_object_unref0 (file);
#line 64 "../src/baobab-scanner.vala"
				file = _tmp18_;
#line 63 "../src/baobab-scanner.vala"
				_g_free0 (name);
#line 446 "baobab-scanner.c"
			}
		}
	}
#line 67 "../src/baobab-scanner.vala"
	result = file;
#line 67 "../src/baobab-scanner.vala"
	(names == NULL) ? NULL : (names = (_g_list_free__g_free0_ (names), NULL));
#line 67 "../src/baobab-scanner.vala"
	return result;
#line 456 "baobab-scanner.c"
}

static void
_vala_array_add3 (BaobabScannerResults** * array,
                  gint* length,
                  gint* size,
                  BaobabScannerResults* value)
{
#line 256 "../src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 256 "../src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 256 "../src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 471 "baobab-scanner.c"
	}
#line 256 "../src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 256 "../src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 477 "baobab-scanner.c"
}

static void
_vala_array_add4 (BaobabScannerResults** * array,
                  gint* length,
                  gint* size,
                  BaobabScannerResults* value)
{
#line 279 "../src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 279 "../src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 279 "../src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 492 "baobab-scanner.c"
	}
#line 279 "../src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 279 "../src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 498 "baobab-scanner.c"
}

static void
baobab_scanner_add_children (BaobabScanner* self,
                             GFile* directory,
                             BaobabScannerResults* results,
                             BaobabScannerResultsArray* results_array,
                             GError** error)
{
	GFileEnumerator* children = NULL;
	GCancellable* _tmp0_;
	GFileEnumerator* _tmp1_;
	GFileInfo* child_info = NULL;
	GError* _inner_error0_ = NULL;
#line 245 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/baobab-scanner.vala"
	g_return_if_fail (directory != NULL);
#line 245 "../src/baobab-scanner.vala"
	g_return_if_fail (results != NULL);
#line 245 "../src/baobab-scanner.vala"
	g_return_if_fail (results_array != NULL);
#line 246 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->cancellable;
#line 246 "../src/baobab-scanner.vala"
	_tmp1_ = g_file_enumerate_children (directory, BAOBAB_SCANNER_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, _tmp0_, &_inner_error0_);
#line 246 "../src/baobab-scanner.vala"
	children = _tmp1_;
#line 246 "../src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/baobab-scanner.vala"
		g_propagate_error (error, _inner_error0_);
#line 246 "../src/baobab-scanner.vala"
		return;
#line 533 "baobab-scanner.c"
	}
#line 248 "../src/baobab-scanner.vala"
	while (TRUE) {
#line 537 "baobab-scanner.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GCancellable* _tmp4_;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
#line 248 "../src/baobab-scanner.vala"
		_tmp3_ = children;
#line 248 "../src/baobab-scanner.vala"
		_tmp4_ = self->priv->cancellable;
#line 248 "../src/baobab-scanner.vala"
		_tmp5_ = g_file_enumerator_next_file (_tmp3_, _tmp4_, &_inner_error0_);
#line 248 "../src/baobab-scanner.vala"
		_tmp2_ = _tmp5_;
#line 248 "../src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/baobab-scanner.vala"
			g_propagate_error (error, _inner_error0_);
#line 248 "../src/baobab-scanner.vala"
			_g_object_unref0 (child_info);
#line 248 "../src/baobab-scanner.vala"
			_g_object_unref0 (children);
#line 248 "../src/baobab-scanner.vala"
			return;
#line 563 "baobab-scanner.c"
		}
#line 248 "../src/baobab-scanner.vala"
		_tmp6_ = _tmp2_;
#line 248 "../src/baobab-scanner.vala"
		_tmp2_ = NULL;
#line 248 "../src/baobab-scanner.vala"
		_g_object_unref0 (child_info);
#line 248 "../src/baobab-scanner.vala"
		child_info = _tmp6_;
#line 248 "../src/baobab-scanner.vala"
		_tmp7_ = child_info;
#line 248 "../src/baobab-scanner.vala"
		if (!(_tmp7_ != NULL)) {
#line 248 "../src/baobab-scanner.vala"
			_g_object_unref0 (_tmp2_);
#line 248 "../src/baobab-scanner.vala"
			break;
#line 581 "baobab-scanner.c"
		}
#line 249 "../src/baobab-scanner.vala"
		_tmp8_ = child_info;
#line 249 "../src/baobab-scanner.vala"
		switch (g_file_info_get_file_type (_tmp8_)) {
#line 249 "../src/baobab-scanner.vala"
			case G_FILE_TYPE_DIRECTORY:
#line 589 "baobab-scanner.c"
			{
				GFile* child = NULL;
				GFileInfo* _tmp9_;
				const gchar* _tmp10_;
				GFile* _tmp11_;
				BaobabScannerResults* child_results = NULL;
				GFile* _tmp12_;
				GFileInfo* _tmp13_;
				BaobabScannerResults* _tmp14_;
				BaobabScannerResults* _tmp15_;
#line 251 "../src/baobab-scanner.vala"
				_tmp9_ = child_info;
#line 251 "../src/baobab-scanner.vala"
				_tmp10_ = g_file_info_get_name (_tmp9_);
#line 251 "../src/baobab-scanner.vala"
				_tmp11_ = g_file_get_child (directory, _tmp10_);
#line 251 "../src/baobab-scanner.vala"
				child = _tmp11_;
#line 252 "../src/baobab-scanner.vala"
				_tmp12_ = child;
#line 252 "../src/baobab-scanner.vala"
				_tmp13_ = child_info;
#line 252 "../src/baobab-scanner.vala"
				_tmp14_ = baobab_scanner_add_directory (self, _tmp12_, _tmp13_, results);
#line 252 "../src/baobab-scanner.vala"
				child_results = _tmp14_;
#line 254 "../src/baobab-scanner.vala"
				_tmp15_ = child_results;
#line 254 "../src/baobab-scanner.vala"
				if (_tmp15_ != NULL) {
#line 620 "baobab-scanner.c"
					BaobabScannerResults* _tmp16_;
					BaobabScannerResults* _tmp17_;
#line 255 "../src/baobab-scanner.vala"
					_tmp16_ = child_results;
#line 255 "../src/baobab-scanner.vala"
					baobab_scanner_results_update_with_child (results, _tmp16_);
#line 256 "../src/baobab-scanner.vala"
					_tmp17_ = child_results;
#line 256 "../src/baobab-scanner.vala"
					child_results = NULL;
#line 256 "../src/baobab-scanner.vala"
					_vala_array_add3 (&results_array->results, &results_array->results_length1, &results_array->_results_size_, _tmp17_);
#line 633 "baobab-scanner.c"
				}
#line 258 "../src/baobab-scanner.vala"
				_g_object_unref0 (child_results);
#line 258 "../src/baobab-scanner.vala"
				_g_object_unref0 (child);
#line 258 "../src/baobab-scanner.vala"
				break;
#line 641 "baobab-scanner.c"
			}
#line 249 "../src/baobab-scanner.vala"
			case G_FILE_TYPE_REGULAR:
#line 645 "baobab-scanner.c"
			{
				GFileInfo* _tmp18_;
				BaobabScannerResults* child_results = NULL;
				GFileInfo* _tmp26_;
				BaobabScannerResults* _tmp27_;
				guint64 _tmp28_;
				BaobabScannerResults* _tmp29_;
				guint64 _tmp30_;
				guint64 _tmp31_;
				gint _tmp32_;
				BaobabScannerResults* _tmp33_;
				BaobabScannerResults* _tmp34_;
#line 261 "../src/baobab-scanner.vala"
				_tmp18_ = child_info;
#line 261 "../src/baobab-scanner.vala"
				if (g_file_info_has_attribute (_tmp18_, G_FILE_ATTRIBUTE_UNIX_NLINK)) {
#line 662 "baobab-scanner.c"
					GFileInfo* _tmp19_;
#line 262 "../src/baobab-scanner.vala"
					_tmp19_ = child_info;
#line 262 "../src/baobab-scanner.vala"
					if (g_file_info_get_attribute_uint32 (_tmp19_, G_FILE_ATTRIBUTE_UNIX_NLINK) > ((guint32) 1)) {
#line 668 "baobab-scanner.c"
						BaobabScannerHardLink* hl = NULL;
						GFileInfo* _tmp20_;
						BaobabScannerHardLink* _tmp21_;
						GHashTable* _tmp22_;
						BaobabScannerHardLink* _tmp23_;
						GHashTable* _tmp24_;
						BaobabScannerHardLink* _tmp25_;
#line 263 "../src/baobab-scanner.vala"
						_tmp20_ = child_info;
#line 263 "../src/baobab-scanner.vala"
						_tmp21_ = baobab_scanner_hard_link_new (_tmp20_);
#line 263 "../src/baobab-scanner.vala"
						hl = _tmp21_;
#line 266 "../src/baobab-scanner.vala"
						_tmp22_ = self->priv->hardlinks;
#line 266 "../src/baobab-scanner.vala"
						_tmp23_ = hl;
#line 266 "../src/baobab-scanner.vala"
						if (g_hash_table_contains (_tmp22_, _tmp23_)) {
#line 267 "../src/baobab-scanner.vala"
							_baobab_scanner_hard_link_free0 (hl);
#line 267 "../src/baobab-scanner.vala"
							_g_object_unref0 (_tmp2_);
#line 267 "../src/baobab-scanner.vala"
							continue;
#line 694 "baobab-scanner.c"
						}
#line 270 "../src/baobab-scanner.vala"
						_tmp24_ = self->priv->hardlinks;
#line 270 "../src/baobab-scanner.vala"
						_tmp25_ = hl;
#line 270 "../src/baobab-scanner.vala"
						hl = NULL;
#line 270 "../src/baobab-scanner.vala"
						g_hash_table_add (_tmp24_, _tmp25_);
#line 262 "../src/baobab-scanner.vala"
						_baobab_scanner_hard_link_free0 (hl);
#line 706 "baobab-scanner.c"
					}
				}
#line 275 "../src/baobab-scanner.vala"
				_tmp26_ = child_info;
#line 275 "../src/baobab-scanner.vala"
				_tmp27_ = baobab_scanner_results_new (_tmp26_, results);
#line 275 "../src/baobab-scanner.vala"
				child_results = _tmp27_;
#line 276 "../src/baobab-scanner.vala"
				_tmp28_ = self->priv->_total_size;
#line 276 "../src/baobab-scanner.vala"
				_tmp29_ = child_results;
#line 276 "../src/baobab-scanner.vala"
				_tmp30_ = baobab_scanner_results_get_size (_tmp29_);
#line 276 "../src/baobab-scanner.vala"
				_tmp31_ = _tmp30_;
#line 276 "../src/baobab-scanner.vala"
				baobab_scanner_set_total_size (self, _tmp28_ + _tmp31_);
#line 277 "../src/baobab-scanner.vala"
				_tmp32_ = self->priv->_total_elements;
#line 277 "../src/baobab-scanner.vala"
				baobab_scanner_set_total_elements (self, _tmp32_ + 1);
#line 278 "../src/baobab-scanner.vala"
				_tmp33_ = child_results;
#line 278 "../src/baobab-scanner.vala"
				baobab_scanner_results_update_with_child (results, _tmp33_);
#line 279 "../src/baobab-scanner.vala"
				_tmp34_ = child_results;
#line 279 "../src/baobab-scanner.vala"
				child_results = NULL;
#line 279 "../src/baobab-scanner.vala"
				_vala_array_add4 (&results_array->results, &results_array->results_length1, &results_array->_results_size_, _tmp34_);
#line 280 "../src/baobab-scanner.vala"
				_g_object_unref0 (child_results);
#line 280 "../src/baobab-scanner.vala"
				break;
#line 743 "baobab-scanner.c"
			}
			default:
			{
#line 284 "../src/baobab-scanner.vala"
				break;
#line 749 "baobab-scanner.c"
			}
		}
#line 248 "../src/baobab-scanner.vala"
		_g_object_unref0 (_tmp2_);
#line 754 "baobab-scanner.c"
	}
#line 245 "../src/baobab-scanner.vala"
	_g_object_unref0 (child_info);
#line 245 "../src/baobab-scanner.vala"
	_g_object_unref0 (children);
#line 760 "baobab-scanner.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 309 "../src/baobab-scanner.vala"
	return self ? g_error_copy (self) : NULL;
#line 768 "baobab-scanner.c"
}

static BaobabScannerResults*
baobab_scanner_add_directory (BaobabScanner* self,
                              GFile* directory,
                              GFileInfo* info,
                              BaobabScannerResults* parent)
{
	BaobabScannerResultsArray* results_array = NULL;
	BaobabScannerResultsArray* _tmp0_;
	guint32 current_unix_device = 0U;
	gboolean _tmp1_ = FALSE;
	BaobabScanFlags _tmp2_;
	BaobabScannerResults* results = NULL;
	BaobabScannerResults* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	guint64 _tmp10_;
	BaobabScannerResults* _tmp11_;
	guint64 _tmp12_;
	guint64 _tmp13_;
	gint _tmp14_;
	BaobabScannerResultsArray* _tmp20_;
	BaobabScannerResults** _tmp21_;
	gint _tmp21__length1;
	GAsyncQueue* _tmp33_;
	BaobabScannerResultsArray* _tmp34_;
	GError* _inner_error0_ = NULL;
	BaobabScannerResults* result;
#line 289 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../src/baobab-scanner.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 289 "../src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 290 "../src/baobab-scanner.vala"
	_tmp0_ = baobab_scanner_results_array_new ();
#line 290 "../src/baobab-scanner.vala"
	results_array = _tmp0_;
#line 292 "../src/baobab-scanner.vala"
	current_unix_device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 293 "../src/baobab-scanner.vala"
	_tmp2_ = self->priv->_scan_flags;
#line 293 "../src/baobab-scanner.vala"
	if ((_tmp2_ & BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS) == BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS) {
#line 293 "../src/baobab-scanner.vala"
		_tmp1_ = current_unix_device != self->priv->unix_device;
#line 818 "baobab-scanner.c"
	} else {
#line 293 "../src/baobab-scanner.vala"
		_tmp1_ = FALSE;
#line 822 "baobab-scanner.c"
	}
#line 293 "../src/baobab-scanner.vala"
	if (_tmp1_) {
#line 294 "../src/baobab-scanner.vala"
		result = NULL;
#line 294 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 294 "../src/baobab-scanner.vala"
		return result;
#line 832 "baobab-scanner.c"
	}
#line 297 "../src/baobab-scanner.vala"
	_tmp3_ = baobab_scanner_results_new (info, parent);
#line 297 "../src/baobab-scanner.vala"
	results = _tmp3_;
#line 298 "../src/baobab-scanner.vala"
	_tmp4_ = self->priv->excluded_locations;
#line 298 "../src/baobab-scanner.vala"
	_tmp5_ = g_file_get_uri (directory);
#line 298 "../src/baobab-scanner.vala"
	_tmp6_ = _tmp5_;
#line 298 "../src/baobab-scanner.vala"
	_tmp7_ = g_hash_table_contains (_tmp4_, _tmp6_);
#line 298 "../src/baobab-scanner.vala"
	_g_free0 (_tmp6_);
#line 298 "../src/baobab-scanner.vala"
	if (_tmp7_) {
#line 850 "baobab-scanner.c"
		BaobabScannerResults* _tmp8_;
		GError* _tmp9_;
#line 299 "../src/baobab-scanner.vala"
		_tmp8_ = results;
#line 299 "../src/baobab-scanner.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Location is excluded");
#line 299 "../src/baobab-scanner.vala"
		_g_error_free0 (_tmp8_->error);
#line 299 "../src/baobab-scanner.vala"
		_tmp8_->error = _tmp9_;
#line 300 "../src/baobab-scanner.vala"
		result = results;
#line 300 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 300 "../src/baobab-scanner.vala"
		return result;
#line 867 "baobab-scanner.c"
	}
#line 303 "../src/baobab-scanner.vala"
	_tmp10_ = self->priv->_total_size;
#line 303 "../src/baobab-scanner.vala"
	_tmp11_ = results;
#line 303 "../src/baobab-scanner.vala"
	_tmp12_ = baobab_scanner_results_get_size (_tmp11_);
#line 303 "../src/baobab-scanner.vala"
	_tmp13_ = _tmp12_;
#line 303 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_size (self, _tmp10_ + _tmp13_);
#line 304 "../src/baobab-scanner.vala"
	_tmp14_ = self->priv->_total_elements;
#line 304 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_elements (self, _tmp14_ + 1);
#line 883 "baobab-scanner.c"
	{
		BaobabScannerResults* _tmp15_;
		BaobabScannerResultsArray* _tmp16_;
#line 307 "../src/baobab-scanner.vala"
		_tmp15_ = results;
#line 307 "../src/baobab-scanner.vala"
		_tmp16_ = results_array;
#line 307 "../src/baobab-scanner.vala"
		baobab_scanner_add_children (self, directory, _tmp15_, _tmp16_, &_inner_error0_);
#line 307 "../src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 895 "baobab-scanner.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		BaobabScannerResults* _tmp17_;
		GError* _tmp18_;
		GError* _tmp19_;
#line 306 "../src/baobab-scanner.vala"
		e = _inner_error0_;
#line 306 "../src/baobab-scanner.vala"
		_inner_error0_ = NULL;
#line 309 "../src/baobab-scanner.vala"
		_tmp17_ = results;
#line 309 "../src/baobab-scanner.vala"
		_tmp18_ = e;
#line 309 "../src/baobab-scanner.vala"
		_tmp19_ = _g_error_copy0 (_tmp18_);
#line 309 "../src/baobab-scanner.vala"
		_g_error_free0 (_tmp17_->error);
#line 309 "../src/baobab-scanner.vala"
		_tmp17_->error = _tmp19_;
#line 306 "../src/baobab-scanner.vala"
		_g_error_free0 (e);
#line 922 "baobab-scanner.c"
	}
	__finally0:
#line 306 "../src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 306 "../src/baobab-scanner.vala"
		_g_object_unref0 (results);
#line 306 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 306 "../src/baobab-scanner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 306 "../src/baobab-scanner.vala"
		g_clear_error (&_inner_error0_);
#line 306 "../src/baobab-scanner.vala"
		return NULL;
#line 937 "baobab-scanner.c"
	}
#line 312 "../src/baobab-scanner.vala"
	_tmp20_ = results_array;
#line 312 "../src/baobab-scanner.vala"
	_tmp21_ = _tmp20_->results;
#line 312 "../src/baobab-scanner.vala"
	_tmp21__length1 = _tmp20_->results_length1;
#line 945 "baobab-scanner.c"
	{
		BaobabScannerResults** child_results_collection = NULL;
		gint child_results_collection_length1 = 0;
		gint _child_results_collection_size_ = 0;
		gint child_results_it = 0;
#line 312 "../src/baobab-scanner.vala"
		child_results_collection = _tmp21_;
#line 312 "../src/baobab-scanner.vala"
		child_results_collection_length1 = _tmp21__length1;
#line 312 "../src/baobab-scanner.vala"
		for (child_results_it = 0; child_results_it < child_results_collection_length1; child_results_it = child_results_it + 1) {
#line 957 "baobab-scanner.c"
			BaobabScannerResults* child_results = NULL;
#line 312 "../src/baobab-scanner.vala"
			child_results = child_results_collection[child_results_it];
#line 961 "baobab-scanner.c"
			{
				BaobabScannerResults* _tmp22_;
				guint64 _tmp23_;
				guint64 _tmp24_;
#line 313 "../src/baobab-scanner.vala"
				_tmp22_ = results;
#line 313 "../src/baobab-scanner.vala"
				_tmp23_ = baobab_scanner_results_get_size (_tmp22_);
#line 313 "../src/baobab-scanner.vala"
				_tmp24_ = _tmp23_;
#line 313 "../src/baobab-scanner.vala"
				if (_tmp24_ > ((guint64) 0)) {
#line 974 "baobab-scanner.c"
					BaobabScannerResults* _tmp25_;
					BaobabScannerResults* _tmp26_;
					guint64 _tmp27_;
					guint64 _tmp28_;
					BaobabScannerResults* _tmp29_;
					guint64 _tmp30_;
					guint64 _tmp31_;
#line 314 "../src/baobab-scanner.vala"
					_tmp25_ = child_results;
#line 314 "../src/baobab-scanner.vala"
					_tmp26_ = child_results;
#line 314 "../src/baobab-scanner.vala"
					_tmp27_ = baobab_scanner_results_get_size (_tmp26_);
#line 314 "../src/baobab-scanner.vala"
					_tmp28_ = _tmp27_;
#line 314 "../src/baobab-scanner.vala"
					_tmp29_ = results;
#line 314 "../src/baobab-scanner.vala"
					_tmp30_ = baobab_scanner_results_get_size (_tmp29_);
#line 314 "../src/baobab-scanner.vala"
					_tmp31_ = _tmp30_;
#line 314 "../src/baobab-scanner.vala"
					baobab_scanner_results_set_percent (_tmp25_, (100 * ((gdouble) _tmp28_)) / ((gdouble) _tmp31_));
#line 998 "baobab-scanner.c"
				} else {
					BaobabScannerResults* _tmp32_;
#line 316 "../src/baobab-scanner.vala"
					_tmp32_ = child_results;
#line 316 "../src/baobab-scanner.vala"
					baobab_scanner_results_set_percent (_tmp32_, (gdouble) 0);
#line 1005 "baobab-scanner.c"
				}
			}
		}
	}
#line 323 "../src/baobab-scanner.vala"
	_tmp33_ = self->priv->results_queue;
#line 323 "../src/baobab-scanner.vala"
	_tmp34_ = results_array;
#line 323 "../src/baobab-scanner.vala"
	results_array = NULL;
#line 323 "../src/baobab-scanner.vala"
	g_async_queue_push (_tmp33_, _tmp34_);
#line 325 "../src/baobab-scanner.vala"
	result = results;
#line 325 "../src/baobab-scanner.vala"
	_baobab_scanner_results_array_free0 (results_array);
#line 325 "../src/baobab-scanner.vala"
	return result;
#line 1024 "baobab-scanner.c"
}

static void
_vala_array_add5 (BaobabScannerResults** * array,
                  gint* length,
                  gint* size,
                  BaobabScannerResults* value)
{
#line 340 "../src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 340 "../src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 340 "../src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 1039 "baobab-scanner.c"
	}
#line 340 "../src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 340 "../src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 1045 "baobab-scanner.c"
}

static void*
baobab_scanner_scan_in_thread (BaobabScanner* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
#line 328 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1055 "baobab-scanner.c"
	{
		BaobabScannerResultsArray* array = NULL;
		BaobabScannerResultsArray* _tmp0_;
		GFileInfo* info = NULL;
		GFile* _tmp1_;
		GCancellable* _tmp2_;
		GFileInfo* _tmp3_;
		BaobabScannerResults* results = NULL;
		GFile* _tmp4_;
		BaobabScannerResults* _tmp5_;
		BaobabScannerResults* _tmp6_;
		BaobabScannerResultsArray* _tmp7_;
		BaobabScannerResultsArray* _tmp8_;
		BaobabScannerResults* _tmp9_;
		GAsyncQueue* _tmp10_;
		BaobabScannerResultsArray* _tmp11_;
#line 330 "../src/baobab-scanner.vala"
		_tmp0_ = baobab_scanner_results_array_new ();
#line 330 "../src/baobab-scanner.vala"
		array = _tmp0_;
#line 331 "../src/baobab-scanner.vala"
		_tmp1_ = self->priv->_directory;
#line 331 "../src/baobab-scanner.vala"
		_tmp2_ = self->priv->cancellable;
#line 331 "../src/baobab-scanner.vala"
		_tmp3_ = g_file_query_info (_tmp1_, BAOBAB_SCANNER_ATTRIBUTES, 0, _tmp2_, &_inner_error0_);
#line 331 "../src/baobab-scanner.vala"
		info = _tmp3_;
#line 331 "../src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 331 "../src/baobab-scanner.vala"
			_baobab_scanner_results_array_free0 (array);
#line 1088 "baobab-scanner.c"
			goto __catch0_g_error;
		}
#line 335 "../src/baobab-scanner.vala"
		baobab_scanner_set_show_allocated_size (self, g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE) > ((guint64) 0));
#line 337 "../src/baobab-scanner.vala"
		self->priv->unix_device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 338 "../src/baobab-scanner.vala"
		_tmp4_ = self->priv->_directory;
#line 338 "../src/baobab-scanner.vala"
		_tmp5_ = baobab_scanner_add_directory (self, _tmp4_, info, NULL);
#line 338 "../src/baobab-scanner.vala"
		results = _tmp5_;
#line 339 "../src/baobab-scanner.vala"
		_tmp6_ = results;
#line 339 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_percent (_tmp6_, 100.0);
#line 340 "../src/baobab-scanner.vala"
		_tmp7_ = array;
#line 340 "../src/baobab-scanner.vala"
		_tmp8_ = array;
#line 340 "../src/baobab-scanner.vala"
		_tmp9_ = results;
#line 340 "../src/baobab-scanner.vala"
		results = NULL;
#line 340 "../src/baobab-scanner.vala"
		_vala_array_add5 (&_tmp7_->results, &_tmp7_->results_length1, &_tmp7_->_results_size_, _tmp9_);
#line 341 "../src/baobab-scanner.vala"
		_tmp10_ = self->priv->results_queue;
#line 341 "../src/baobab-scanner.vala"
		_tmp11_ = array;
#line 341 "../src/baobab-scanner.vala"
		array = NULL;
#line 341 "../src/baobab-scanner.vala"
		g_async_queue_push (_tmp10_, _tmp11_);
#line 329 "../src/baobab-scanner.vala"
		_g_object_unref0 (results);
#line 329 "../src/baobab-scanner.vala"
		_g_object_unref0 (info);
#line 329 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (array);
#line 1129 "baobab-scanner.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 329 "../src/baobab-scanner.vala"
		g_clear_error (&_inner_error0_);
#line 1136 "baobab-scanner.c"
	}
	__finally0:
#line 329 "../src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../src/baobab-scanner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../src/baobab-scanner.vala"
		g_clear_error (&_inner_error0_);
#line 329 "../src/baobab-scanner.vala"
		return NULL;
#line 1147 "baobab-scanner.c"
	}
#line 346 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->self);
#line 346 "../src/baobab-scanner.vala"
	self->priv->self = NULL;
#line 347 "../src/baobab-scanner.vala"
	result = NULL;
#line 347 "../src/baobab-scanner.vala"
	return result;
#line 1157 "baobab-scanner.c"
}

static gboolean
baobab_scanner_process_results (BaobabScanner* self)
{
	BaobabScanner* _tmp30_;
	gboolean result;
#line 350 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 351 "../src/baobab-scanner.vala"
	while (TRUE) {
#line 1169 "baobab-scanner.c"
		BaobabScannerResultsArray* results_array = NULL;
		GAsyncQueue* _tmp0_;
		gpointer _tmp1_;
		BaobabScannerResultsArray* _tmp2_;
		BaobabScannerResultsArray* _tmp3_;
		BaobabScannerResults** _tmp4_;
		gint _tmp4__length1;
#line 352 "../src/baobab-scanner.vala"
		_tmp0_ = self->priv->results_queue;
#line 352 "../src/baobab-scanner.vala"
		_tmp1_ = g_async_queue_try_pop (_tmp0_);
#line 352 "../src/baobab-scanner.vala"
		results_array = (BaobabScannerResultsArray*) _tmp1_;
#line 354 "../src/baobab-scanner.vala"
		_tmp2_ = results_array;
#line 354 "../src/baobab-scanner.vala"
		if (_tmp2_ == NULL) {
#line 355 "../src/baobab-scanner.vala"
			_baobab_scanner_results_array_free0 (results_array);
#line 355 "../src/baobab-scanner.vala"
			break;
#line 1191 "baobab-scanner.c"
		}
#line 358 "../src/baobab-scanner.vala"
		_tmp3_ = results_array;
#line 358 "../src/baobab-scanner.vala"
		_tmp4_ = _tmp3_->results;
#line 358 "../src/baobab-scanner.vala"
		_tmp4__length1 = _tmp3_->results_length1;
#line 1199 "baobab-scanner.c"
		{
			BaobabScannerResults** results_collection = NULL;
			gint results_collection_length1 = 0;
			gint _results_collection_size_ = 0;
			gint results_it = 0;
#line 358 "../src/baobab-scanner.vala"
			results_collection = _tmp4_;
#line 358 "../src/baobab-scanner.vala"
			results_collection_length1 = _tmp4__length1;
#line 358 "../src/baobab-scanner.vala"
			for (results_it = 0; results_it < results_collection_length1; results_it = results_it + 1) {
#line 1211 "baobab-scanner.c"
				BaobabScannerResults* results = NULL;
#line 358 "../src/baobab-scanner.vala"
				results = results_collection[results_it];
#line 1215 "baobab-scanner.c"
				{
					BaobabScannerResults* _tmp5_;
					BaobabScannerResults* _tmp6_;
					BaobabScannerResults* _tmp7_;
					BaobabScannerState state = 0;
					BaobabScannerResults* _tmp14_;
					BaobabScannerResults* _tmp20_;
					gint _tmp21_;
					BaobabScannerResults* _tmp23_;
					BaobabScannerResults* _tmp24_;
					BaobabScannerResults* _tmp25_;
#line 359 "../src/baobab-scanner.vala"
					_tmp5_ = results;
#line 359 "../src/baobab-scanner.vala"
					_tmp6_ = baobab_scanner_results_get_parent (_tmp5_);
#line 359 "../src/baobab-scanner.vala"
					_tmp7_ = _tmp6_;
#line 359 "../src/baobab-scanner.vala"
					if (_tmp7_ != NULL) {
#line 1235 "baobab-scanner.c"
						BaobabScannerResults* _tmp8_;
						BaobabScannerResults* _tmp9_;
						BaobabScannerResults* _tmp10_;
						GListStore* _tmp11_;
						GListStore* _tmp12_;
						BaobabScannerResults* _tmp13_;
#line 360 "../src/baobab-scanner.vala"
						_tmp8_ = results;
#line 360 "../src/baobab-scanner.vala"
						_tmp9_ = baobab_scanner_results_get_parent (_tmp8_);
#line 360 "../src/baobab-scanner.vala"
						_tmp10_ = _tmp9_;
#line 360 "../src/baobab-scanner.vala"
						_tmp11_ = baobab_scanner_results_get_children_list_store (_tmp10_);
#line 360 "../src/baobab-scanner.vala"
						_tmp12_ = _tmp11_;
#line 360 "../src/baobab-scanner.vala"
						_tmp13_ = results;
#line 360 "../src/baobab-scanner.vala"
						g_list_store_insert (_tmp12_, (guint) 0, (GObject*) _tmp13_);
#line 1256 "baobab-scanner.c"
					}
#line 364 "../src/baobab-scanner.vala"
					_tmp14_ = results;
#line 364 "../src/baobab-scanner.vala"
					if (_tmp14_->child_error) {
#line 1262 "baobab-scanner.c"
						BaobabScannerResults* _tmp15_;
#line 365 "../src/baobab-scanner.vala"
						_tmp15_ = results;
#line 365 "../src/baobab-scanner.vala"
						baobab_scanner_results_set_state (_tmp15_, BAOBAB_SCANNER_STATE_CHILD_ERROR);
#line 1268 "baobab-scanner.c"
					} else {
						BaobabScannerResults* _tmp16_;
						GError* _tmp17_;
#line 366 "../src/baobab-scanner.vala"
						_tmp16_ = results;
#line 366 "../src/baobab-scanner.vala"
						_tmp17_ = _tmp16_->error;
#line 366 "../src/baobab-scanner.vala"
						if (_tmp17_ != NULL) {
#line 1278 "baobab-scanner.c"
							BaobabScannerResults* _tmp18_;
#line 367 "../src/baobab-scanner.vala"
							_tmp18_ = results;
#line 367 "../src/baobab-scanner.vala"
							baobab_scanner_results_set_state (_tmp18_, BAOBAB_SCANNER_STATE_ERROR);
#line 1284 "baobab-scanner.c"
						} else {
							BaobabScannerResults* _tmp19_;
#line 369 "../src/baobab-scanner.vala"
							_tmp19_ = results;
#line 369 "../src/baobab-scanner.vala"
							baobab_scanner_results_set_state (_tmp19_, BAOBAB_SCANNER_STATE_DONE);
#line 1291 "baobab-scanner.c"
						}
					}
#line 372 "../src/baobab-scanner.vala"
					_tmp20_ = results;
#line 372 "../src/baobab-scanner.vala"
					_tmp21_ = self->priv->_max_depth;
#line 372 "../src/baobab-scanner.vala"
					if (_tmp20_->max_depth > _tmp21_) {
#line 1300 "baobab-scanner.c"
						BaobabScannerResults* _tmp22_;
#line 373 "../src/baobab-scanner.vala"
						_tmp22_ = results;
#line 373 "../src/baobab-scanner.vala"
						baobab_scanner_set_max_depth (self, _tmp22_->max_depth);
#line 1306 "baobab-scanner.c"
					}
#line 377 "../src/baobab-scanner.vala"
					_tmp23_ = results;
#line 377 "../src/baobab-scanner.vala"
					_tmp24_ = baobab_scanner_results_get_parent (_tmp23_);
#line 377 "../src/baobab-scanner.vala"
					_tmp25_ = _tmp24_;
#line 377 "../src/baobab-scanner.vala"
					if (_tmp25_ == NULL) {
#line 1316 "baobab-scanner.c"
						BaobabScannerResults* _tmp26_;
						BaobabScannerResults* _tmp27_;
						GError* _tmp28_;
						GError* _tmp29_;
#line 378 "../src/baobab-scanner.vala"
						_tmp26_ = results;
#line 378 "../src/baobab-scanner.vala"
						baobab_scanner_set_root (self, _tmp26_);
#line 379 "../src/baobab-scanner.vala"
						_tmp27_ = results;
#line 379 "../src/baobab-scanner.vala"
						_tmp28_ = _tmp27_->error;
#line 379 "../src/baobab-scanner.vala"
						_tmp29_ = _g_error_copy0 (_tmp28_);
#line 379 "../src/baobab-scanner.vala"
						_g_error_free0 (self->priv->scan_error);
#line 379 "../src/baobab-scanner.vala"
						self->priv->scan_error = _tmp29_;
#line 380 "../src/baobab-scanner.vala"
						self->priv->successful = TRUE;
#line 381 "../src/baobab-scanner.vala"
						g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 382 "../src/baobab-scanner.vala"
						result = FALSE;
#line 382 "../src/baobab-scanner.vala"
						_baobab_scanner_results_array_free0 (results_array);
#line 382 "../src/baobab-scanner.vala"
						return result;
#line 1345 "baobab-scanner.c"
					}
				}
			}
		}
#line 351 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 1352 "baobab-scanner.c"
	}
#line 387 "../src/baobab-scanner.vala"
	_tmp30_ = self->priv->self;
#line 387 "../src/baobab-scanner.vala"
	result = _tmp30_ != NULL;
#line 387 "../src/baobab-scanner.vala"
	return result;
#line 1360 "baobab-scanner.c"
}

static guint
_baobab_scanner_hard_link_hash_ghash_func (gconstpointer key)
{
	guint result;
	result = baobab_scanner_hard_link_hash (key);
#line 409 "../src/baobab-scanner.vala"
	return result;
#line 1370 "baobab-scanner.c"
}

static gboolean
_baobab_scanner_hard_link_equal_gequal_func (gconstpointer a,
                                             gconstpointer b)
{
	gboolean result;
	result = baobab_scanner_hard_link_equal (a, (BaobabScannerHardLink*) b);
#line 409 "../src/baobab-scanner.vala"
	return result;
#line 1381 "baobab-scanner.c"
}

static void
_baobab_scanner_hard_link_free0_ (gpointer var)
{
#line 409 "../src/baobab-scanner.vala"
	(var == NULL) ? NULL : (var = (baobab_scanner_hard_link_free (var), NULL));
#line 1389 "baobab-scanner.c"
}

static void
baobab_scanner_cancel_and_reset (BaobabScanner* self)
{
	GCancellable* _tmp0_;
	GThread* _tmp1_;
	BaobabScannerResultsArray* tmp = NULL;
	GAsyncQueue* _tmp3_;
	gpointer _tmp4_;
	GHashTable* _tmp8_;
	GCancellable* _tmp9_;
	BaobabApplication* _tmp10_;
	BaobabApplication* _tmp11_;
	GHashTable* _tmp12_;
#line 390 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->cancellable;
#line 391 "../src/baobab-scanner.vala"
	g_cancellable_cancel (_tmp0_);
#line 393 "../src/baobab-scanner.vala"
	_tmp1_ = self->priv->thread;
#line 393 "../src/baobab-scanner.vala"
	if (_tmp1_ != NULL) {
#line 1415 "baobab-scanner.c"
		GThread* _tmp2_;
#line 394 "../src/baobab-scanner.vala"
		_tmp2_ = self->priv->thread;
#line 394 "../src/baobab-scanner.vala"
		self->priv->thread = NULL;
#line 394 "../src/baobab-scanner.vala"
		g_thread_join (_tmp2_);
#line 395 "../src/baobab-scanner.vala"
		_g_thread_unref0 (self->priv->thread);
#line 395 "../src/baobab-scanner.vala"
		self->priv->thread = NULL;
#line 1427 "baobab-scanner.c"
	}
#line 398 "../src/baobab-scanner.vala"
	if (self->priv->process_result_idle != ((guint) 0)) {
#line 399 "../src/baobab-scanner.vala"
		g_source_remove (self->priv->process_result_idle);
#line 400 "../src/baobab-scanner.vala"
		self->priv->process_result_idle = (guint) 0;
#line 1435 "baobab-scanner.c"
	}
#line 404 "../src/baobab-scanner.vala"
	_tmp3_ = self->priv->results_queue;
#line 404 "../src/baobab-scanner.vala"
	_tmp4_ = g_async_queue_try_pop (_tmp3_);
#line 404 "../src/baobab-scanner.vala"
	tmp = (BaobabScannerResultsArray*) _tmp4_;
#line 405 "../src/baobab-scanner.vala"
	while (TRUE) {
#line 1445 "baobab-scanner.c"
		BaobabScannerResultsArray* _tmp5_;
		GAsyncQueue* _tmp6_;
		gpointer _tmp7_;
#line 405 "../src/baobab-scanner.vala"
		_tmp5_ = tmp;
#line 405 "../src/baobab-scanner.vala"
		if (!(_tmp5_ != NULL)) {
#line 405 "../src/baobab-scanner.vala"
			break;
#line 1455 "baobab-scanner.c"
		}
#line 406 "../src/baobab-scanner.vala"
		_tmp6_ = self->priv->results_queue;
#line 406 "../src/baobab-scanner.vala"
		_tmp7_ = g_async_queue_try_pop (_tmp6_);
#line 406 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (tmp);
#line 406 "../src/baobab-scanner.vala"
		tmp = (BaobabScannerResultsArray*) _tmp7_;
#line 1465 "baobab-scanner.c"
	}
#line 409 "../src/baobab-scanner.vala"
	_tmp8_ = g_hash_table_new_full (_baobab_scanner_hard_link_hash_ghash_func, _baobab_scanner_hard_link_equal_gequal_func, NULL, _baobab_scanner_hard_link_free0_);
#line 409 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->hardlinks);
#line 409 "../src/baobab-scanner.vala"
	self->priv->hardlinks = _tmp8_;
#line 411 "../src/baobab-scanner.vala"
	_tmp9_ = self->priv->cancellable;
#line 411 "../src/baobab-scanner.vala"
	g_cancellable_reset (_tmp9_);
#line 412 "../src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 412 "../src/baobab-scanner.vala"
	self->priv->scan_error = NULL;
#line 413 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_size (self, (guint64) 0);
#line 414 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_elements (self, 0);
#line 416 "../src/baobab-scanner.vala"
	_tmp10_ = baobab_application_get_default ();
#line 416 "../src/baobab-scanner.vala"
	_tmp11_ = _tmp10_;
#line 416 "../src/baobab-scanner.vala"
	_tmp12_ = baobab_application_get_excluded_locations (_tmp11_);
#line 416 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->excluded_locations);
#line 416 "../src/baobab-scanner.vala"
	self->priv->excluded_locations = _tmp12_;
#line 416 "../src/baobab-scanner.vala"
	_g_object_unref0 (_tmp11_);
#line 390 "../src/baobab-scanner.vala"
	_baobab_scanner_results_array_free0 (tmp);
#line 1499 "baobab-scanner.c"
}

static gpointer
_baobab_scanner_scan_in_thread_gthread_func (gpointer self)
{
	gpointer result;
	result = baobab_scanner_scan_in_thread ((BaobabScanner*) self);
#line 430 "../src/baobab-scanner.vala"
	g_object_unref (self);
#line 430 "../src/baobab-scanner.vala"
	return result;
#line 1511 "baobab-scanner.c"
}

static gboolean
___lambda6_ (BaobabScanner* self)
{
	gboolean res = FALSE;
	gboolean result;
#line 433 "../src/baobab-scanner.vala"
	res = baobab_scanner_process_results (self);
#line 434 "../src/baobab-scanner.vala"
	if (!res) {
#line 435 "../src/baobab-scanner.vala"
		self->priv->process_result_idle = (guint) 0;
#line 1525 "baobab-scanner.c"
	}
#line 437 "../src/baobab-scanner.vala"
	result = res;
#line 437 "../src/baobab-scanner.vala"
	return result;
#line 1531 "baobab-scanner.c"
}

static gboolean
____lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda6_ ((BaobabScanner*) self);
#line 432 "../src/baobab-scanner.vala"
	return result;
#line 1541 "baobab-scanner.c"
}

void
baobab_scanner_scan (BaobabScanner* self,
                     gboolean force)
{
#line 419 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/baobab-scanner.vala"
	if (force) {
#line 421 "../src/baobab-scanner.vala"
		self->priv->successful = FALSE;
#line 1554 "baobab-scanner.c"
	}
#line 424 "../src/baobab-scanner.vala"
	if (!self->priv->successful) {
#line 1558 "baobab-scanner.c"
		BaobabScanner* _tmp0_;
		GThread* _tmp1_;
#line 425 "../src/baobab-scanner.vala"
		baobab_scanner_cancel_and_reset (self);
#line 428 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (self);
#line 428 "../src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->self);
#line 428 "../src/baobab-scanner.vala"
		self->priv->self = _tmp0_;
#line 430 "../src/baobab-scanner.vala"
		_tmp1_ = g_thread_new ("scanner", _baobab_scanner_scan_in_thread_gthread_func, g_object_ref (self));
#line 430 "../src/baobab-scanner.vala"
		_g_thread_unref0 (self->priv->thread);
#line 430 "../src/baobab-scanner.vala"
		self->priv->thread = _tmp1_;
#line 432 "../src/baobab-scanner.vala"
		self->priv->process_result_idle = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 1577 "baobab-scanner.c"
	} else {
#line 440 "../src/baobab-scanner.vala"
		g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 1581 "baobab-scanner.c"
	}
}

void
baobab_scanner_cancel (BaobabScanner* self)
{
#line 444 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 445 "../src/baobab-scanner.vala"
	if (!self->priv->successful) {
#line 1592 "baobab-scanner.c"
		GError* _tmp0_;
#line 446 "../src/baobab-scanner.vala"
		baobab_scanner_cancel_and_reset (self);
#line 447 "../src/baobab-scanner.vala"
		_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Scan was cancelled");
#line 447 "../src/baobab-scanner.vala"
		_g_error_free0 (self->priv->scan_error);
#line 447 "../src/baobab-scanner.vala"
		self->priv->scan_error = _tmp0_;
#line 1602 "baobab-scanner.c"
	}
#line 449 "../src/baobab-scanner.vala"
	g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 1606 "baobab-scanner.c"
}

void
baobab_scanner_finish (BaobabScanner* self,
                       GError** error)
{
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 452 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->scan_error;
#line 453 "../src/baobab-scanner.vala"
	if (_tmp0_ != NULL) {
#line 1621 "baobab-scanner.c"
		GError* _tmp1_;
		GError* _tmp2_;
#line 454 "../src/baobab-scanner.vala"
		_tmp1_ = self->priv->scan_error;
#line 454 "../src/baobab-scanner.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 454 "../src/baobab-scanner.vala"
		_inner_error0_ = _tmp2_;
#line 454 "../src/baobab-scanner.vala"
		g_propagate_error (error, _inner_error0_);
#line 454 "../src/baobab-scanner.vala"
		return;
#line 1634 "baobab-scanner.c"
	}
}

static void
_baobab_scanner_results_array_free0_ (gpointer var)
{
#line 464 "../src/baobab-scanner.vala"
	(var == NULL) ? NULL : (var = (baobab_scanner_results_array_free (var), NULL));
#line 1643 "baobab-scanner.c"
}

BaobabScanner*
baobab_scanner_construct (GType object_type,
                          GFile* directory,
                          BaobabScanFlags flags)
{
	BaobabScanner * self = NULL;
	GCancellable* _tmp0_;
	GAsyncQueue* _tmp1_;
#line 458 "../src/baobab-scanner.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 458 "../src/baobab-scanner.vala"
	self = (BaobabScanner*) g_object_new (object_type, NULL);
#line 459 "../src/baobab-scanner.vala"
	baobab_scanner_set_directory (self, directory);
#line 460 "../src/baobab-scanner.vala"
	baobab_scanner_set_scan_flags (self, flags);
#line 461 "../src/baobab-scanner.vala"
	_tmp0_ = g_cancellable_new ();
#line 461 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 461 "../src/baobab-scanner.vala"
	self->priv->cancellable = _tmp0_;
#line 462 "../src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 462 "../src/baobab-scanner.vala"
	self->priv->scan_error = NULL;
#line 464 "../src/baobab-scanner.vala"
	_tmp1_ = g_async_queue_new_full (_baobab_scanner_results_array_free0_);
#line 464 "../src/baobab-scanner.vala"
	_g_async_queue_unref0 (self->priv->results_queue);
#line 464 "../src/baobab-scanner.vala"
	self->priv->results_queue = _tmp1_;
#line 458 "../src/baobab-scanner.vala"
	return self;
#line 1680 "baobab-scanner.c"
}

BaobabScanner*
baobab_scanner_new (GFile* directory,
                    BaobabScanFlags flags)
{
#line 458 "../src/baobab-scanner.vala"
	return baobab_scanner_construct (BAOBAB_TYPE_SCANNER, directory, flags);
#line 1689 "baobab-scanner.c"
}

BaobabScannerResults*
baobab_scanner_get_root (BaobabScanner* self)
{
	BaobabScannerResults* result;
	BaobabScannerResults* _tmp0_;
#line 39 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_root;
#line 39 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 39 "../src/baobab-scanner.vala"
	return result;
#line 1705 "baobab-scanner.c"
}

void
baobab_scanner_set_root (BaobabScanner* self,
                         BaobabScannerResults* value)
{
	BaobabScannerResults* old_value;
#line 39 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_root (self);
#line 39 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 1719 "baobab-scanner.c"
		BaobabScannerResults* _tmp0_;
#line 39 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->_root);
#line 39 "../src/baobab-scanner.vala"
		self->priv->_root = _tmp0_;
#line 39 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_ROOT_PROPERTY]);
#line 1729 "baobab-scanner.c"
	}
}

GFile*
baobab_scanner_get_directory (BaobabScanner* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 41 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_directory;
#line 41 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 41 "../src/baobab-scanner.vala"
	return result;
#line 1746 "baobab-scanner.c"
}

static void
baobab_scanner_set_directory (BaobabScanner* self,
                              GFile* value)
{
	GFile* old_value;
#line 41 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_directory (self);
#line 41 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 1760 "baobab-scanner.c"
		GFile* _tmp0_;
#line 41 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->_directory);
#line 41 "../src/baobab-scanner.vala"
		self->priv->_directory = _tmp0_;
#line 41 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_DIRECTORY_PROPERTY]);
#line 1770 "baobab-scanner.c"
	}
}

BaobabScanFlags
baobab_scanner_get_scan_flags (BaobabScanner* self)
{
	BaobabScanFlags result;
#line 43 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 43 "../src/baobab-scanner.vala"
	result = self->priv->_scan_flags;
#line 43 "../src/baobab-scanner.vala"
	return result;
#line 1784 "baobab-scanner.c"
}

static void
baobab_scanner_set_scan_flags (BaobabScanner* self,
                               BaobabScanFlags value)
{
	BaobabScanFlags old_value;
#line 43 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_scan_flags (self);
#line 43 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 43 "../src/baobab-scanner.vala"
		self->priv->_scan_flags = value;
#line 43 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY]);
#line 1802 "baobab-scanner.c"
	}
}

gboolean
baobab_scanner_get_show_allocated_size (BaobabScanner* self)
{
	gboolean result;
#line 45 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../src/baobab-scanner.vala"
	result = self->priv->_show_allocated_size;
#line 45 "../src/baobab-scanner.vala"
	return result;
#line 1816 "baobab-scanner.c"
}

static void
baobab_scanner_set_show_allocated_size (BaobabScanner* self,
                                        gboolean value)
{
	gboolean old_value;
#line 45 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_show_allocated_size (self);
#line 45 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 45 "../src/baobab-scanner.vala"
		self->priv->_show_allocated_size = value;
#line 45 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY]);
#line 1834 "baobab-scanner.c"
	}
}

guint64
baobab_scanner_get_total_size (BaobabScanner* self)
{
	guint64 result;
#line 48 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 48 "../src/baobab-scanner.vala"
	result = self->priv->_total_size;
#line 48 "../src/baobab-scanner.vala"
	return result;
#line 1848 "baobab-scanner.c"
}

static void
baobab_scanner_set_total_size (BaobabScanner* self,
                               guint64 value)
{
	guint64 old_value;
#line 48 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_total_size (self);
#line 48 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 48 "../src/baobab-scanner.vala"
		self->priv->_total_size = value;
#line 48 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY]);
#line 1866 "baobab-scanner.c"
	}
}

gint
baobab_scanner_get_total_elements (BaobabScanner* self)
{
	gint result;
#line 49 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../src/baobab-scanner.vala"
	result = self->priv->_total_elements;
#line 49 "../src/baobab-scanner.vala"
	return result;
#line 1880 "baobab-scanner.c"
}

static void
baobab_scanner_set_total_elements (BaobabScanner* self,
                                   gint value)
{
	gint old_value;
#line 49 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_total_elements (self);
#line 49 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 49 "../src/baobab-scanner.vala"
		self->priv->_total_elements = value;
#line 49 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY]);
#line 1898 "baobab-scanner.c"
	}
}

gint
baobab_scanner_get_max_depth (BaobabScanner* self)
{
	gint result;
#line 51 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "../src/baobab-scanner.vala"
	result = self->priv->_max_depth;
#line 51 "../src/baobab-scanner.vala"
	return result;
#line 1912 "baobab-scanner.c"
}

void
baobab_scanner_set_max_depth (BaobabScanner* self,
                              gint value)
{
	gint old_value;
#line 51 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_max_depth (self);
#line 51 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 51 "../src/baobab-scanner.vala"
		self->priv->_max_depth = value;
#line 51 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_MAX_DEPTH_PROPERTY]);
#line 1930 "baobab-scanner.c"
	}
}

static BaobabScannerHardLink*
baobab_scanner_hard_link_new (GFileInfo* info)
{
	BaobabScannerHardLink* self;
#line 87 "../src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 87 "../src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerHardLink);
#line 87 "../src/baobab-scanner.vala"
	baobab_scanner_hard_link_instance_init (self);
#line 88 "../src/baobab-scanner.vala"
	self->inode = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_UNIX_INODE);
#line 89 "../src/baobab-scanner.vala"
	self->device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 87 "../src/baobab-scanner.vala"
	return self;
#line 1950 "baobab-scanner.c"
}

static guint
baobab_scanner_hard_link_hash (BaobabScannerHardLink* self)
{
	GHashFunc _tmp0_;
	GHashFunc _tmp1_;
	guint result;
#line 92 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 93 "../src/baobab-scanner.vala"
	_tmp0_ = g_direct_hash;
#line 93 "../src/baobab-scanner.vala"
	_tmp1_ = g_direct_hash;
#line 93 "../src/baobab-scanner.vala"
	result = _tmp0_ ((void*) self->inode) ^ _tmp1_ ((void*) self->device);
#line 93 "../src/baobab-scanner.vala"
	return result;
#line 1969 "baobab-scanner.c"
}

static gboolean
baobab_scanner_hard_link_equal (BaobabScannerHardLink* self,
                                BaobabScannerHardLink* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 96 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../src/baobab-scanner.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 97 "../src/baobab-scanner.vala"
	if (self->inode == other->inode) {
#line 97 "../src/baobab-scanner.vala"
		_tmp0_ = self->device == other->device;
#line 1986 "baobab-scanner.c"
	} else {
#line 97 "../src/baobab-scanner.vala"
		_tmp0_ = FALSE;
#line 1990 "baobab-scanner.c"
	}
#line 97 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 97 "../src/baobab-scanner.vala"
	return result;
#line 1996 "baobab-scanner.c"
}

static void
baobab_scanner_hard_link_instance_init (BaobabScannerHardLink * self)
{
}

static void
baobab_scanner_hard_link_free (BaobabScannerHardLink * self)
{
#line 83 "../src/baobab-scanner.vala"
	g_slice_free (BaobabScannerHardLink, self);
#line 2009 "baobab-scanner.c"
}

static BaobabScannerResultsArray*
baobab_scanner_results_array_new (void)
{
	BaobabScannerResultsArray* self;
#line 146 "../src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerResultsArray);
#line 146 "../src/baobab-scanner.vala"
	baobab_scanner_results_array_instance_init (self);
#line 146 "../src/baobab-scanner.vala"
	return self;
#line 2022 "baobab-scanner.c"
}

static void
baobab_scanner_results_array_instance_init (BaobabScannerResultsArray * self)
{
}

static void
baobab_scanner_results_array_free (BaobabScannerResultsArray * self)
{
#line 147 "../src/baobab-scanner.vala"
	self->results = (_vala_array_free (self->results, self->results_length1, (GDestroyNotify) g_object_unref), NULL);
#line 146 "../src/baobab-scanner.vala"
	g_slice_free (BaobabScannerResultsArray, self);
#line 2037 "baobab-scanner.c"
}

static inline gpointer
baobab_scanner_results_get_instance_private (BaobabScannerResults* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabScannerResults_private_offset);
}

BaobabScannerResults*
baobab_scanner_results_construct (GType object_type,
                                  GFileInfo* info,
                                  BaobabScannerResults* parent_results)
{
	BaobabScannerResults * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp8_;
	guint64 _tmp9_;
#line 189 "../src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 189 "../src/baobab-scanner.vala"
	self = (BaobabScannerResults*) g_object_new (object_type, NULL);
#line 190 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_parent (self, parent_results);
#line 191 "../src/baobab-scanner.vala"
	_tmp0_ = g_file_info_get_name (info);
#line 191 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_name (self, _tmp0_);
#line 192 "../src/baobab-scanner.vala"
	_tmp1_ = g_file_info_get_display_name (info);
#line 192 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_display_name (self, _tmp1_);
#line 193 "../src/baobab-scanner.vala"
	_tmp3_ = self->priv->_display_name;
#line 193 "../src/baobab-scanner.vala"
	if (_tmp3_ == NULL) {
#line 2076 "baobab-scanner.c"
		const gchar* _tmp4_;
#line 193 "../src/baobab-scanner.vala"
		_tmp4_ = self->priv->_name;
#line 193 "../src/baobab-scanner.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 2082 "baobab-scanner.c"
	} else {
#line 193 "../src/baobab-scanner.vala"
		_tmp2_ = FALSE;
#line 2086 "baobab-scanner.c"
	}
#line 193 "../src/baobab-scanner.vala"
	if (_tmp2_) {
#line 2090 "baobab-scanner.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 194 "../src/baobab-scanner.vala"
		_tmp5_ = self->priv->_name;
#line 194 "../src/baobab-scanner.vala"
		_tmp6_ = g_filename_display_name (_tmp5_);
#line 194 "../src/baobab-scanner.vala"
		_tmp7_ = _tmp6_;
#line 194 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_display_name (self, _tmp7_);
#line 194 "../src/baobab-scanner.vala"
		_g_free0 (_tmp7_);
#line 2104 "baobab-scanner.c"
	}
#line 196 "../src/baobab-scanner.vala"
	_tmp8_ = self->priv->_display_name;
#line 196 "../src/baobab-scanner.vala"
	if (_tmp8_ == NULL) {
#line 197 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_display_name (self, "");
#line 2112 "baobab-scanner.c"
	}
#line 199 "../src/baobab-scanner.vala"
	self->file_type = g_file_info_get_file_type (info);
#line 200 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_size (self, g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE));
#line 201 "../src/baobab-scanner.vala"
	_tmp9_ = self->priv->_size;
#line 201 "../src/baobab-scanner.vala"
	if (_tmp9_ == ((guint64) 0)) {
#line 202 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_size (self, (guint64) g_file_info_get_size (info));
#line 2124 "baobab-scanner.c"
	}
#line 204 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_time_modified (self, g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_TIME_MODIFIED));
#line 205 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_elements (self, 1);
#line 206 "../src/baobab-scanner.vala"
	_g_error_free0 (self->error);
#line 206 "../src/baobab-scanner.vala"
	self->error = NULL;
#line 207 "../src/baobab-scanner.vala"
	self->child_error = FALSE;
#line 189 "../src/baobab-scanner.vala"
	return self;
#line 2138 "baobab-scanner.c"
}

BaobabScannerResults*
baobab_scanner_results_new (GFileInfo* info,
                            BaobabScannerResults* parent_results)
{
#line 189 "../src/baobab-scanner.vala"
	return baobab_scanner_results_construct (BAOBAB_SCANNER_TYPE_RESULTS, info, parent_results);
#line 2147 "baobab-scanner.c"
}

BaobabScannerResults*
baobab_scanner_results_construct_empty (GType object_type)
{
	BaobabScannerResults * self = NULL;
#line 210 "../src/baobab-scanner.vala"
	self = (BaobabScannerResults*) g_object_new (object_type, NULL);
#line 210 "../src/baobab-scanner.vala"
	return self;
#line 2158 "baobab-scanner.c"
}

BaobabScannerResults*
baobab_scanner_results_new_empty (void)
{
#line 210 "../src/baobab-scanner.vala"
	return baobab_scanner_results_construct_empty (BAOBAB_SCANNER_TYPE_RESULTS);
#line 2166 "baobab-scanner.c"
}

void
baobab_scanner_results_update_with_child (BaobabScannerResults* self,
                                          BaobabScannerResults* child)
{
	guint64 _tmp0_;
	guint64 _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	guint64 _tmp6_;
	guint64 _tmp7_;
#line 213 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/baobab-scanner.vala"
	g_return_if_fail (child != NULL);
#line 214 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_size;
#line 214 "../src/baobab-scanner.vala"
	_tmp1_ = child->priv->_size;
#line 214 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_size (self, _tmp0_ + _tmp1_);
#line 215 "../src/baobab-scanner.vala"
	_tmp2_ = self->priv->_elements;
#line 215 "../src/baobab-scanner.vala"
	_tmp3_ = child->priv->_elements;
#line 215 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_elements (self, _tmp2_ + _tmp3_);
#line 216 "../src/baobab-scanner.vala"
	self->max_depth = MAX (self->max_depth, child->max_depth + 1);
#line 217 "../src/baobab-scanner.vala"
	if (child->child_error) {
#line 217 "../src/baobab-scanner.vala"
		_tmp4_ = TRUE;
#line 2202 "baobab-scanner.c"
	} else {
		GError* _tmp5_;
#line 217 "../src/baobab-scanner.vala"
		_tmp5_ = child->error;
#line 217 "../src/baobab-scanner.vala"
		_tmp4_ = _tmp5_ != NULL;
#line 2209 "baobab-scanner.c"
	}
#line 217 "../src/baobab-scanner.vala"
	self->child_error = self->child_error | _tmp4_;
#line 218 "../src/baobab-scanner.vala"
	_tmp6_ = self->priv->_time_modified;
#line 218 "../src/baobab-scanner.vala"
	_tmp7_ = child->priv->_time_modified;
#line 218 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_time_modified (self, MAX (_tmp6_, _tmp7_));
#line 2219 "baobab-scanner.c"
}

gint
baobab_scanner_results_get_depth (BaobabScannerResults* self)
{
	gint depth = 0;
	gint result;
#line 221 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 222 "../src/baobab-scanner.vala"
	depth = 1;
#line 2231 "baobab-scanner.c"
	{
		BaobabScannerResults* ancestor = NULL;
		BaobabScannerResults* _tmp0_;
		BaobabScannerResults* _tmp1_;
#line 223 "../src/baobab-scanner.vala"
		_tmp0_ = self->priv->_parent;
#line 223 "../src/baobab-scanner.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 223 "../src/baobab-scanner.vala"
		ancestor = _tmp1_;
#line 2242 "baobab-scanner.c"
		{
			gboolean _tmp2_ = FALSE;
#line 223 "../src/baobab-scanner.vala"
			_tmp2_ = TRUE;
#line 223 "../src/baobab-scanner.vala"
			while (TRUE) {
#line 2249 "baobab-scanner.c"
				BaobabScannerResults* _tmp6_;
				gint _tmp7_;
#line 223 "../src/baobab-scanner.vala"
				if (!_tmp2_) {
#line 2254 "baobab-scanner.c"
					BaobabScannerResults* _tmp3_;
					BaobabScannerResults* _tmp4_;
					BaobabScannerResults* _tmp5_;
#line 223 "../src/baobab-scanner.vala"
					_tmp3_ = ancestor;
#line 223 "../src/baobab-scanner.vala"
					_tmp4_ = _tmp3_->priv->_parent;
#line 223 "../src/baobab-scanner.vala"
					_tmp5_ = _g_object_ref0 (_tmp4_);
#line 223 "../src/baobab-scanner.vala"
					_g_object_unref0 (ancestor);
#line 223 "../src/baobab-scanner.vala"
					ancestor = _tmp5_;
#line 2268 "baobab-scanner.c"
				}
#line 223 "../src/baobab-scanner.vala"
				_tmp2_ = FALSE;
#line 223 "../src/baobab-scanner.vala"
				_tmp6_ = ancestor;
#line 223 "../src/baobab-scanner.vala"
				if (!(_tmp6_ != NULL)) {
#line 223 "../src/baobab-scanner.vala"
					break;
#line 2278 "baobab-scanner.c"
				}
#line 224 "../src/baobab-scanner.vala"
				_tmp7_ = depth;
#line 224 "../src/baobab-scanner.vala"
				depth = _tmp7_ + 1;
#line 2284 "baobab-scanner.c"
			}
		}
#line 223 "../src/baobab-scanner.vala"
		_g_object_unref0 (ancestor);
#line 2289 "baobab-scanner.c"
	}
#line 226 "../src/baobab-scanner.vala"
	result = depth;
#line 226 "../src/baobab-scanner.vala"
	return result;
#line 2295 "baobab-scanner.c"
}

gboolean
baobab_scanner_results_is_ancestor (BaobabScannerResults* self,
                                    BaobabScannerResults* descendant)
{
	gboolean result;
#line 229 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2305 "baobab-scanner.c"
	{
		gboolean _tmp0_ = FALSE;
#line 230 "../src/baobab-scanner.vala"
		_tmp0_ = TRUE;
#line 230 "../src/baobab-scanner.vala"
		while (TRUE) {
#line 230 "../src/baobab-scanner.vala"
			if (!_tmp0_) {
#line 2314 "baobab-scanner.c"
				BaobabScannerResults* _tmp1_;
#line 230 "../src/baobab-scanner.vala"
				_tmp1_ = descendant->priv->_parent;
#line 230 "../src/baobab-scanner.vala"
				descendant = _tmp1_;
#line 2320 "baobab-scanner.c"
			}
#line 230 "../src/baobab-scanner.vala"
			_tmp0_ = FALSE;
#line 230 "../src/baobab-scanner.vala"
			if (!(descendant != NULL)) {
#line 230 "../src/baobab-scanner.vala"
				break;
#line 2328 "baobab-scanner.c"
			}
#line 231 "../src/baobab-scanner.vala"
			if (descendant == self) {
#line 232 "../src/baobab-scanner.vala"
				result = TRUE;
#line 232 "../src/baobab-scanner.vala"
				return result;
#line 2336 "baobab-scanner.c"
			}
		}
	}
#line 234 "../src/baobab-scanner.vala"
	result = descendant == self;
#line 234 "../src/baobab-scanner.vala"
	return result;
#line 2344 "baobab-scanner.c"
}

static GListModel*
__lambda4_ (BaobabScannerResults* self,
            GObject* item)
{
	BaobabScannerResults* results = NULL;
	BaobabScannerResults* _tmp0_;
	GListStore* _tmp1_ = NULL;
	BaobabScannerResults* _tmp2_;
	GListModel* _tmp5_;
	GListModel* result;
#line 238 "../src/baobab-scanner.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 239 "../src/baobab-scanner.vala"
	_tmp0_ = _g_object_ref0 (BAOBAB_SCANNER_IS_RESULTS (item) ? ((BaobabScannerResults*) item) : NULL);
#line 239 "../src/baobab-scanner.vala"
	results = _tmp0_;
#line 240 "../src/baobab-scanner.vala"
	_tmp2_ = results;
#line 240 "../src/baobab-scanner.vala"
	if (_tmp2_ == NULL) {
#line 240 "../src/baobab-scanner.vala"
		_tmp1_ = NULL;
#line 2369 "baobab-scanner.c"
	} else {
		BaobabScannerResults* _tmp3_;
		GListStore* _tmp4_;
#line 240 "../src/baobab-scanner.vala"
		_tmp3_ = results;
#line 240 "../src/baobab-scanner.vala"
		_tmp4_ = _tmp3_->priv->_children_list_store;
#line 240 "../src/baobab-scanner.vala"
		_tmp1_ = _tmp4_;
#line 2379 "baobab-scanner.c"
	}
#line 240 "../src/baobab-scanner.vala"
	_tmp5_ = _g_object_ref0 ((GListModel*) _tmp1_);
#line 240 "../src/baobab-scanner.vala"
	result = _tmp5_;
#line 240 "../src/baobab-scanner.vala"
	_g_object_unref0 (results);
#line 240 "../src/baobab-scanner.vala"
	return result;
#line 2389 "baobab-scanner.c"
}

static GListModel*
___lambda4__gtk_tree_list_model_create_model_func (GObject* item,
                                                   gpointer self)
{
	GListModel* result;
	result = __lambda4_ ((BaobabScannerResults*) self, item);
#line 238 "../src/baobab-scanner.vala"
	return result;
#line 2400 "baobab-scanner.c"
}

GtkTreeListModel*
baobab_scanner_results_create_tree_model (BaobabScannerResults* self)
{
	GListStore* _tmp0_;
	GListModel* _tmp1_;
	GtkTreeListModel* _tmp2_;
	GtkTreeListModel* result;
#line 237 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_children_list_store;
#line 238 "../src/baobab-scanner.vala"
	_tmp1_ = _g_object_ref0 ((GListModel*) _tmp0_);
#line 238 "../src/baobab-scanner.vala"
	_tmp2_ = gtk_tree_list_model_new (_tmp1_, FALSE, FALSE, ___lambda4__gtk_tree_list_model_create_model_func, g_object_ref (self), g_object_unref);
#line 238 "../src/baobab-scanner.vala"
	result = _tmp2_;
#line 238 "../src/baobab-scanner.vala"
	return result;
#line 2422 "baobab-scanner.c"
}

BaobabScannerResults*
baobab_scanner_results_get_parent (BaobabScannerResults* self)
{
	BaobabScannerResults* result;
	BaobabScannerResults* _tmp0_;
#line 153 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_parent;
#line 153 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 153 "../src/baobab-scanner.vala"
	return result;
#line 2438 "baobab-scanner.c"
}

void
baobab_scanner_results_set_parent (BaobabScannerResults* self,
                                   BaobabScannerResults* value)
{
	BaobabScannerResults* old_value;
#line 153 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_parent (self);
#line 153 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 153 "../src/baobab-scanner.vala"
		self->priv->_parent = value;
#line 153 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_PARENT_PROPERTY]);
#line 2456 "baobab-scanner.c"
	}
}

const gchar*
baobab_scanner_results_get_name (BaobabScannerResults* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 154 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 154 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_name;
#line 154 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 154 "../src/baobab-scanner.vala"
	return result;
#line 2473 "baobab-scanner.c"
}

void
baobab_scanner_results_set_name (BaobabScannerResults* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 154 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_name (self);
#line 154 "../src/baobab-scanner.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2487 "baobab-scanner.c"
		gchar* _tmp0_;
#line 154 "../src/baobab-scanner.vala"
		_tmp0_ = g_strdup (value);
#line 154 "../src/baobab-scanner.vala"
		_g_free0 (self->priv->_name);
#line 154 "../src/baobab-scanner.vala"
		self->priv->_name = _tmp0_;
#line 154 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_NAME_PROPERTY]);
#line 2497 "baobab-scanner.c"
	}
}

const gchar*
baobab_scanner_results_get_display_name (BaobabScannerResults* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 155 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 155 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_display_name;
#line 155 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 155 "../src/baobab-scanner.vala"
	return result;
#line 2514 "baobab-scanner.c"
}

void
baobab_scanner_results_set_display_name (BaobabScannerResults* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 155 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_display_name (self);
#line 155 "../src/baobab-scanner.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2528 "baobab-scanner.c"
		gchar* _tmp0_;
#line 155 "../src/baobab-scanner.vala"
		_tmp0_ = g_strdup (value);
#line 155 "../src/baobab-scanner.vala"
		_g_free0 (self->priv->_display_name);
#line 155 "../src/baobab-scanner.vala"
		self->priv->_display_name = _tmp0_;
#line 155 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_DISPLAY_NAME_PROPERTY]);
#line 2538 "baobab-scanner.c"
	}
}

guint64
baobab_scanner_results_get_size (BaobabScannerResults* self)
{
	guint64 result;
#line 160 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 160 "../src/baobab-scanner.vala"
	result = self->priv->_size;
#line 160 "../src/baobab-scanner.vala"
	return result;
#line 2552 "baobab-scanner.c"
}

void
baobab_scanner_results_set_size (BaobabScannerResults* self,
                                 guint64 value)
{
	guint64 old_value;
#line 160 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_size (self);
#line 160 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 160 "../src/baobab-scanner.vala"
		self->priv->_size = value;
#line 160 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_SIZE_PROPERTY]);
#line 2570 "baobab-scanner.c"
	}
}

guint64
baobab_scanner_results_get_time_modified (BaobabScannerResults* self)
{
	guint64 result;
#line 161 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 161 "../src/baobab-scanner.vala"
	result = self->priv->_time_modified;
#line 161 "../src/baobab-scanner.vala"
	return result;
#line 2584 "baobab-scanner.c"
}

void
baobab_scanner_results_set_time_modified (BaobabScannerResults* self,
                                          guint64 value)
{
	guint64 old_value;
#line 161 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_time_modified (self);
#line 161 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 161 "../src/baobab-scanner.vala"
		self->priv->_time_modified = value;
#line 161 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_TIME_MODIFIED_PROPERTY]);
#line 2602 "baobab-scanner.c"
	}
}

gint
baobab_scanner_results_get_elements (BaobabScannerResults* self)
{
	gint result;
#line 162 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 162 "../src/baobab-scanner.vala"
	result = self->priv->_elements;
#line 162 "../src/baobab-scanner.vala"
	return result;
#line 2616 "baobab-scanner.c"
}

void
baobab_scanner_results_set_elements (BaobabScannerResults* self,
                                     gint value)
{
	gint old_value;
#line 162 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_elements (self);
#line 162 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 162 "../src/baobab-scanner.vala"
		self->priv->_elements = value;
#line 162 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_ELEMENTS_PROPERTY]);
#line 2634 "baobab-scanner.c"
	}
}

gdouble
baobab_scanner_results_get_percent (BaobabScannerResults* self)
{
	gdouble result;
#line 163 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 163 "../src/baobab-scanner.vala"
	result = self->priv->_percent;
#line 163 "../src/baobab-scanner.vala"
	return result;
#line 2648 "baobab-scanner.c"
}

void
baobab_scanner_results_set_percent (BaobabScannerResults* self,
                                    gdouble value)
{
	gdouble old_value;
#line 163 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_percent (self);
#line 163 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 163 "../src/baobab-scanner.vala"
		self->priv->_percent = value;
#line 163 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_PERCENT_PROPERTY]);
#line 2666 "baobab-scanner.c"
	}
}

GListStore*
baobab_scanner_results_get_children_list_store (BaobabScannerResults* self)
{
	GListStore* result;
	GListStore* _tmp0_;
#line 169 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_children_list_store;
#line 169 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 169 "../src/baobab-scanner.vala"
	return result;
#line 2683 "baobab-scanner.c"
}

void
baobab_scanner_results_set_children_list_store (BaobabScannerResults* self,
                                                GListStore* value)
{
	GListStore* old_value;
#line 169 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_children_list_store (self);
#line 169 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 2697 "baobab-scanner.c"
		GListStore* _tmp0_;
#line 169 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 169 "../src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->_children_list_store);
#line 169 "../src/baobab-scanner.vala"
		self->priv->_children_list_store = _tmp0_;
#line 169 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_CHILDREN_LIST_STORE_PROPERTY]);
#line 2707 "baobab-scanner.c"
	}
}

BaobabScannerState
baobab_scanner_results_get_state (BaobabScannerResults* self)
{
	BaobabScannerState result;
#line 170 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 170 "../src/baobab-scanner.vala"
	result = self->priv->_state;
#line 170 "../src/baobab-scanner.vala"
	return result;
#line 2721 "baobab-scanner.c"
}

void
baobab_scanner_results_set_state (BaobabScannerResults* self,
                                  BaobabScannerState value)
{
	BaobabScannerState old_value;
#line 170 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_results_get_state (self);
#line 170 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 170 "../src/baobab-scanner.vala"
		self->priv->_state = value;
#line 170 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_STATE_PROPERTY]);
#line 2739 "baobab-scanner.c"
	}
}

gdouble
baobab_scanner_results_get_fraction (BaobabScannerResults* self)
{
	gdouble result;
#line 173 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 174 "../src/baobab-scanner.vala"
	result = self->priv->_percent / 100.0;
#line 174 "../src/baobab-scanner.vala"
	return result;
#line 2753 "baobab-scanner.c"
}

gboolean
baobab_scanner_results_get_is_empty (BaobabScannerResults* self)
{
	gboolean result;
	GListStore* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 181 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_children_list_store;
#line 181 "../src/baobab-scanner.vala"
	g_object_get (_tmp0_, "n-items", &_tmp1_, NULL);
#line 181 "../src/baobab-scanner.vala"
	_tmp2_ = _tmp1_;
#line 181 "../src/baobab-scanner.vala"
	result = _tmp2_ == ((guint) 0);
#line 181 "../src/baobab-scanner.vala"
	return result;
#line 2775 "baobab-scanner.c"
}

static void
_baobab_scanner_results___lambda5_ (BaobabScannerResults* self)
{
#line 186 "../src/baobab-scanner.vala"
	g_object_notify ((GObject*) self, "fraction");
#line 2783 "baobab-scanner.c"
}

static void
__baobab_scanner_results___lambda5__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 186 "../src/baobab-scanner.vala"
	_baobab_scanner_results___lambda5_ ((BaobabScannerResults*) self);
#line 2793 "baobab-scanner.c"
}

static GObject *
baobab_scanner_results_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BaobabScannerResults * self;
	GListStore* _tmp0_;
	GListStore* _tmp1_;
#line 184 "../src/baobab-scanner.vala"
	parent_class = G_OBJECT_CLASS (baobab_scanner_results_parent_class);
#line 184 "../src/baobab-scanner.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 184 "../src/baobab-scanner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_SCANNER_TYPE_RESULTS, BaobabScannerResults);
#line 185 "../src/baobab-scanner.vala"
	_tmp0_ = g_list_store_new (BAOBAB_SCANNER_TYPE_RESULTS);
#line 185 "../src/baobab-scanner.vala"
	_tmp1_ = _tmp0_;
#line 185 "../src/baobab-scanner.vala"
	baobab_scanner_results_set_children_list_store (self, _tmp1_);
#line 185 "../src/baobab-scanner.vala"
	_g_object_unref0 (_tmp1_);
#line 186 "../src/baobab-scanner.vala"
	g_signal_connect_object ((GObject*) self, "notify::percent", (GCallback) __baobab_scanner_results___lambda5__g_object_notify, self, 0);
#line 184 "../src/baobab-scanner.vala"
	return obj;
#line 2824 "baobab-scanner.c"
}

static void
baobab_scanner_results_class_init (BaobabScannerResultsClass * klass,
                                   gpointer klass_data)
{
#line 150 "../src/baobab-scanner.vala"
	baobab_scanner_results_parent_class = g_type_class_peek_parent (klass);
#line 150 "../src/baobab-scanner.vala"
	g_type_class_adjust_private_offset (klass, &BaobabScannerResults_private_offset);
#line 150 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_baobab_scanner_results_get_property;
#line 150 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_baobab_scanner_results_set_property;
#line 150 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->constructor = baobab_scanner_results_constructor;
#line 150 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_scanner_results_finalize;
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_PARENT_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", BAOBAB_SCANNER_TYPE_RESULTS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_NAME_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_DISPLAY_NAME_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_SIZE_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_SIZE_PROPERTY] = g_param_spec_uint64 ("size", "size", "size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_TIME_MODIFIED_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_TIME_MODIFIED_PROPERTY] = g_param_spec_uint64 ("time-modified", "time-modified", "time-modified", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_ELEMENTS_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_ELEMENTS_PROPERTY] = g_param_spec_int ("elements", "elements", "elements", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_PERCENT_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_PERCENT_PROPERTY] = g_param_spec_double ("percent", "percent", "percent", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_CHILDREN_LIST_STORE_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_CHILDREN_LIST_STORE_PROPERTY] = g_param_spec_object ("children-list-store", "children-list-store", "children-list-store", g_list_store_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_STATE_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", BAOBAB_SCANNER_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_FRACTION_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_FRACTION_PROPERTY] = g_param_spec_double ("fraction", "fraction", "fraction", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 150 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_RESULTS_IS_EMPTY_PROPERTY, baobab_scanner_results_properties[BAOBAB_SCANNER_RESULTS_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2865 "baobab-scanner.c"
}

static void
baobab_scanner_results_instance_init (BaobabScannerResults * self,
                                      gpointer klass)
{
#line 150 "../src/baobab-scanner.vala"
	self->priv = baobab_scanner_results_get_instance_private (self);
#line 2874 "baobab-scanner.c"
}

static void
baobab_scanner_results_finalize (GObject * obj)
{
	BaobabScannerResults * self;
#line 150 "../src/baobab-scanner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_SCANNER_TYPE_RESULTS, BaobabScannerResults);
#line 154 "../src/baobab-scanner.vala"
	_g_free0 (self->priv->_name);
#line 155 "../src/baobab-scanner.vala"
	_g_free0 (self->priv->_display_name);
#line 165 "../src/baobab-scanner.vala"
	_g_error_free0 (self->error);
#line 169 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->_children_list_store);
#line 150 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (baobab_scanner_results_parent_class)->finalize (obj);
#line 2893 "baobab-scanner.c"
}

static GType
baobab_scanner_results_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabScannerResultsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_scanner_results_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabScannerResults), 0, (GInstanceInitFunc) baobab_scanner_results_instance_init, NULL };
	GType baobab_scanner_results_type_id;
	baobab_scanner_results_type_id = g_type_register_static (G_TYPE_OBJECT, "BaobabScannerResults", &g_define_type_info, 0);
	BaobabScannerResults_private_offset = g_type_add_instance_private (baobab_scanner_results_type_id, sizeof (BaobabScannerResultsPrivate));
	return baobab_scanner_results_type_id;
}

GType
baobab_scanner_results_get_type (void)
{
	static volatile gsize baobab_scanner_results_type_id__once = 0;
	if (g_once_init_enter (&baobab_scanner_results_type_id__once)) {
		GType baobab_scanner_results_type_id;
		baobab_scanner_results_type_id = baobab_scanner_results_get_type_once ();
		g_once_init_leave (&baobab_scanner_results_type_id__once, baobab_scanner_results_type_id);
	}
	return baobab_scanner_results_type_id__once;
}

static void
_vala_baobab_scanner_results_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	BaobabScannerResults * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_SCANNER_TYPE_RESULTS, BaobabScannerResults);
#line 150 "../src/baobab-scanner.vala"
	switch (property_id) {
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_PARENT_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_object (value, baobab_scanner_results_get_parent (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_NAME_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_string (value, baobab_scanner_results_get_name (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_DISPLAY_NAME_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_string (value, baobab_scanner_results_get_display_name (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_SIZE_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_uint64 (value, baobab_scanner_results_get_size (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_TIME_MODIFIED_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_uint64 (value, baobab_scanner_results_get_time_modified (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_ELEMENTS_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_int (value, baobab_scanner_results_get_elements (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_PERCENT_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_double (value, baobab_scanner_results_get_percent (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_CHILDREN_LIST_STORE_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_object (value, baobab_scanner_results_get_children_list_store (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_STATE_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_enum (value, baobab_scanner_results_get_state (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_FRACTION_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_double (value, baobab_scanner_results_get_fraction (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_IS_EMPTY_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		g_value_set_boolean (value, baobab_scanner_results_get_is_empty (self));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 2994 "baobab-scanner.c"
		default:
#line 150 "../src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 150 "../src/baobab-scanner.vala"
		break;
#line 3000 "baobab-scanner.c"
	}
}

static void
_vala_baobab_scanner_results_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	BaobabScannerResults * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_SCANNER_TYPE_RESULTS, BaobabScannerResults);
#line 150 "../src/baobab-scanner.vala"
	switch (property_id) {
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_PARENT_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_parent (self, g_value_get_object (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_NAME_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_name (self, g_value_get_string (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_DISPLAY_NAME_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_display_name (self, g_value_get_string (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_SIZE_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_size (self, g_value_get_uint64 (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_TIME_MODIFIED_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_time_modified (self, g_value_get_uint64 (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_ELEMENTS_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_elements (self, g_value_get_int (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_PERCENT_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_percent (self, g_value_get_double (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_CHILDREN_LIST_STORE_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_children_list_store (self, g_value_get_object (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 150 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_RESULTS_STATE_PROPERTY:
#line 150 "../src/baobab-scanner.vala"
		baobab_scanner_results_set_state (self, g_value_get_enum (value));
#line 150 "../src/baobab-scanner.vala"
		break;
#line 3068 "baobab-scanner.c"
		default:
#line 150 "../src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 150 "../src/baobab-scanner.vala"
		break;
#line 3074 "baobab-scanner.c"
	}
}

static void
baobab_scanner_class_init (BaobabScannerClass * klass,
                           gpointer klass_data)
{
#line 31 "../src/baobab-scanner.vala"
	baobab_scanner_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/baobab-scanner.vala"
	g_type_class_adjust_private_offset (klass, &BaobabScanner_private_offset);
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_baobab_scanner_get_property;
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_baobab_scanner_set_property;
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_scanner_finalize;
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_ROOT_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_ROOT_PROPERTY] = g_param_spec_object ("root", "root", "root", BAOBAB_SCANNER_TYPE_RESULTS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_DIRECTORY_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_DIRECTORY_PROPERTY] = g_param_spec_object ("directory", "directory", "directory", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY] = g_param_spec_flags ("scan-flags", "scan-flags", "scan-flags", BAOBAB_TYPE_SCAN_FLAGS, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY] = g_param_spec_boolean ("show-allocated-size", "show-allocated-size", "show-allocated-size", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY] = g_param_spec_uint64 ("total-size", "total-size", "total-size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY] = g_param_spec_int ("total-elements", "total-elements", "total-elements", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_MAX_DEPTH_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_MAX_DEPTH_PROPERTY] = g_param_spec_int ("max-depth", "max-depth", "max-depth", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "../src/baobab-scanner.vala"
	baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL] = g_signal_new ("completed", BAOBAB_TYPE_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3108 "baobab-scanner.c"
}

static void
baobab_scanner_instance_init (BaobabScanner * self,
                              gpointer klass)
{
#line 31 "../src/baobab-scanner.vala"
	self->priv = baobab_scanner_get_instance_private (self);
#line 101 "../src/baobab-scanner.vala"
	self->priv->thread = NULL;
#line 102 "../src/baobab-scanner.vala"
	self->priv->process_result_idle = (guint) 0;
#line 106 "../src/baobab-scanner.vala"
	self->priv->unix_device = (guint32) 0;
#line 108 "../src/baobab-scanner.vala"
	self->priv->successful = FALSE;
#line 3125 "baobab-scanner.c"
}

static void
baobab_scanner_finalize (GObject * obj)
{
	BaobabScanner * self;
#line 31 "../src/baobab-scanner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 39 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->_root);
#line 41 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->_directory);
#line 101 "../src/baobab-scanner.vala"
	_g_thread_unref0 (self->priv->thread);
#line 104 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->hardlinks);
#line 105 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->excluded_locations);
#line 140 "../src/baobab-scanner.vala"
	_g_async_queue_unref0 (self->priv->results_queue);
#line 141 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->self);
#line 142 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 143 "../src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (baobab_scanner_parent_class)->finalize (obj);
#line 3154 "baobab-scanner.c"
}

static GType
baobab_scanner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabScannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_scanner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabScanner), 0, (GInstanceInitFunc) baobab_scanner_instance_init, NULL };
	GType baobab_scanner_type_id;
	baobab_scanner_type_id = g_type_register_static (G_TYPE_OBJECT, "BaobabScanner", &g_define_type_info, 0);
	BaobabScanner_private_offset = g_type_add_instance_private (baobab_scanner_type_id, sizeof (BaobabScannerPrivate));
	return baobab_scanner_type_id;
}

GType
baobab_scanner_get_type (void)
{
	static volatile gsize baobab_scanner_type_id__once = 0;
	if (g_once_init_enter (&baobab_scanner_type_id__once)) {
		GType baobab_scanner_type_id;
		baobab_scanner_type_id = baobab_scanner_get_type_once ();
		g_once_init_leave (&baobab_scanner_type_id__once, baobab_scanner_type_id);
	}
	return baobab_scanner_type_id__once;
}

static void
_vala_baobab_scanner_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	BaobabScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 31 "../src/baobab-scanner.vala"
	switch (property_id) {
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_ROOT_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_object (value, baobab_scanner_get_root (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_DIRECTORY_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_object (value, baobab_scanner_get_directory (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_flags (value, baobab_scanner_get_scan_flags (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_boolean (value, baobab_scanner_get_show_allocated_size (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_uint64 (value, baobab_scanner_get_total_size (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_int (value, baobab_scanner_get_total_elements (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_MAX_DEPTH_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_int (value, baobab_scanner_get_max_depth (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 3231 "baobab-scanner.c"
		default:
#line 31 "../src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/baobab-scanner.vala"
		break;
#line 3237 "baobab-scanner.c"
	}
}

static void
_vala_baobab_scanner_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	BaobabScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 31 "../src/baobab-scanner.vala"
	switch (property_id) {
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_ROOT_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_root (self, g_value_get_object (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_DIRECTORY_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_directory (self, g_value_get_object (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_scan_flags (self, g_value_get_flags (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_show_allocated_size (self, g_value_get_boolean (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_total_size (self, g_value_get_uint64 (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_total_elements (self, g_value_get_int (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_MAX_DEPTH_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_max_depth (self, g_value_get_int (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 3293 "baobab-scanner.c"
		default:
#line 31 "../src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/baobab-scanner.vala"
		break;
#line 3299 "baobab-scanner.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 64 "../src/baobab-progress-cell.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 3310 "baobab-scanner.c"
		gssize i;
#line 64 "../src/baobab-progress-cell.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 64 "../src/baobab-progress-cell.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 64 "../src/baobab-progress-cell.vala"
				destroy_func (((gpointer*) array)[i]);
#line 3318 "baobab-scanner.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 64 "../src/baobab-progress-cell.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 64 "../src/baobab-progress-cell.vala"
	g_free (array);
#line 3333 "baobab-scanner.c"
}

